<?php

/*
 * This file is used for controlling the data for the Add / Edit page
 */

include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/admin/model/db.php');

$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();

global $wp_roles;

$post_types = get_post_types(array('public' => true));

// If the user saves a optin fire

if ( isset($_POST['submit-top']) && check_admin_referer(self::$prefix . 'admin_settings')) {

	if ( empty($_POST[self::$prefix_dash . 'name']) ) {
		?>
		<script type="text/javascript">
			window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
		</script>
		<?php
	}

	$optin_fire = NNRobots_Optin_Fire_Admin_Functions::save_data();

	// Save optin

	$optin_fire['id'] = $_GET['optin_fire_id'];
	$nnrobots_optin_fire_db->update_data($optin_fire);
}

$default_optin_fire = NNRobots_Optin_Fire_Admin_Functions::default_optin_fire();

// Check if updating a record or adding a new one

if ( isset($_GET["type"]) && $_GET["type"] == 'test') {
	$edit_data = $nnrobots_optin_fire_db->get_data_from_id($_GET["optin_fire_id"]);

	$edit_data['id'] = -1;
	$edit_data['optin_id'] = $_GET["optin_fire_id"];
}

else if ( isset($_GET["optin_fire_id"]) ) {
	$edit_data = $nnrobots_optin_fire_db->get_data_from_id($_GET["optin_fire_id"]);
}

else {

	// Create default values from all post types

	$trigger = $default_optin_fire['trigger'];

	foreach ($post_types as $post_type) {
		$trigger[$post_type] = array(
			'all'	=>	true,
			'id'	=>	''
		);
	}

	$trigger['type'] = 'site';
	$trigger['category'] = array(
		'all' 	=> true,
		'id' 	=> ''
	);
	$trigger['tag'] = array(
		'id' => ''
	);

	$edit_data = array_merge($default_optin_fire, array('trigger' => $trigger));
}

// Check if this is an A/B Test parent

$test_parent = '';

if ( $edit_data['id'] == -1 ) {
	$test_parent = 'hidden';
}

// Check if this is a variant

$in_test = '';

if ( $edit_data['id'] != -1 && isset($edit_data['args']['ab_testing']['active']) && $edit_data['args']['ab_testing']['active'] ) {
	$in_test = 'hidden';
}

// Include the Add Edit php file for all settings

require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/admin/views/add-edit.php');

$post_types_array = array();
foreach ($post_types as $post_type) {
	$post_types_array[] = $post_type;
}

wp_localize_script(self::$prefix . 'admin_add_edit_js', 'nnr_of_add_edit_data', array(
	'ajaxurl'       => admin_url( 'admin-ajax.php' ),
	'prefix'		=> self::$prefix,
	'prefix_dash' 	=> self::$prefix_dash,
	'post_types'	=> $post_types_array,
	'optin'			=> $edit_data,
));