<?php

/*
 * This file is used for controlling the data for the dashboard page
 */

// Setup cron jobs

if ( ! wp_next_scheduled('initialize_optin_fire_stats_daily_cron')) {
	wp_schedule_event( time(), 'daily', 'initialize_optin_fire_stats_daily_cron');
}

if ( ! wp_next_scheduled('setup_optin_fire_email_stats_cron')) {
	wp_schedule_event( time(), 'daily', 'setup_optin_fire_email_stats_cron');
}

include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/admin/model/db.php');
include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/admin/model/list-table.php');

// Init model and controller classes

$nnrobots_optin_fire_list_table = new NNRobots_Optin_Fire_List_Table();
$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();

// Get the counts

$all_count = count( $nnrobots_optin_fire_db->get_optin_fires() );
$active_count = count( $nnrobots_optin_fire_db->get_active() );
$inactive_count = count( $nnrobots_optin_fire_db->get_inactive() );

// Preview

if (isset($_REQUEST["action"]) && $_REQUEST["action"] == "preview") {

	$optin_fire_preview = '';

	// Check nonce

	if (isset($_REQUEST['wp_nonce']) && wp_verify_nonce($_REQUEST['wp_nonce'], self::$prefix . 'preview')) {

		global $wpdb;

		$optin = $nnrobots_optin_fire_db->get_data_from_id($_GET['optin_fire_id']);

		if ($optin['type'] == '5') {
			$optin_fire_preview = NNRobots_Optin_Fire_Functions::generate_code($optin, $optin['news_letter'], true);
		} else {
			$optin_fire_preview = NNRobots_Optin_Fire_Functions::generate_code($optin, $optin['news_letter']);
		}
	}

	echo $optin_fire_preview;
}

// Dismiss notice

if (isset($_GET['action']) && $_GET['action'] != '' && isset($_GET['notice']) && $_GET['notice'] != '') {
	delete_transient(self::$prefix . 'admin_notice_' . $_GET['notice']);

	?>
	<script type="text/javascript">
		window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
	</script>
	<?php
}

require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/admin/views/dashboard.php');

wp_localize_script(self::$prefix . 'admin_js', 'nnr_of_data', array(
	'prefix_dash' 	=> self::$prefix_dash,
));