<?php

/*
 * This file is used for controlling the data for the stats page
 */

include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/admin/model/db.php');

// Create Table if one does not exist

global $wpdb;

NNRobots_Stats_OF::createTable();

$start_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, mktime(0, 0, 0, date("m")-1, date("d"), date("Y")));
$end_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, strtotime(current_time('mysql')));

if (isset($_GET[self::$prefix_dash . 'start-date']) && $_GET[self::$prefix_dash . 'start-date'] != '') {
	$start_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, strtotime($_GET[self::$prefix_dash . 'start-date']));
}

if (isset($_GET[self::$prefix_dash . 'end-date']) && $_GET[self::$prefix_dash . 'end-date'] != '') {
	$end_date = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT, strtotime($_GET[self::$prefix_dash . 'end-date']));
}

if (isset($_GET['action']) && $_GET['action'] == 'ab-testing') {

	$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();
	$optin_fire = $nnrobots_optin_fire_db->get_data_from_id($_GET['optin_fire_id']);
	$optin_fire['args'] = unserialize($optin_fire['args']);

}

// Get global settings

$global_settings = get_option(self::$prefix . 'global_settings');

if ( $global_settings === false ) {
	$global_settings = NNRobots_Optin_Fire_Admin_Functions::default_global_settings();
}

// Save A/B Testing settings

if (isset($_GET['action']) && $_GET['action'] == 'ab-testing' && isset($_GET['action1']) && check_admin_referer(self::$prefix . 'ab_testing')) {

	$optin_fire = $nnrobots_optin_fire_db->get_data_from_id($_GET['optin_fire_id']);

	$optin_fire['social']         = unserialize($optin_fire['social']);
	$optin_fire['news_letter']    = unserialize($optin_fire['news_letter']);
	$optin_fire['template']       = unserialize($optin_fire['template']);
	$optin_fire['trigger']        = unserialize($optin_fire['trigger']);
	$optin_fire['style']          = unserialize($optin_fire['style']);
	$optin_fire['args']           = unserialize($optin_fire['args']);

	if ($_GET['action1'] == 'start') {

		$optin_fire['args']['ab_testing']['active'] = true;
		$optin_fire['args']['ab_testing']['start_date'] = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT);

		// Create new optin_fire with same settings as current one.

		$ab_optin_fire = $optin_fire;
		$ab_optin_fire['name'] .= ' A/B Testing';
		$ab_optin_fire['args']['ab_testing']['active'] = true;
		$ab_optin_fire['args']['ab_testing']['optin_fire_id'] = $optin_fire['id'];
		$ab_optin_fire['args']['ab_testing']['start_date'] = date(NNROBOTS_OPTIN_FIRE_DATE_FORMAT);
		$nnrobots_optin_fire_db->add_data($ab_optin_fire);

		$optin_fire['args']['ab_testing']['optin_fire_id'] = $wpdb->insert_id;

	} else if ($_GET['action1'] == 'stop') {
		$optin_fire['args']['ab_testing']['active'] = false;
		$ab_optin_fire = $nnrobots_optin_fire_db->get_data_from_id($optin_fire['args']['ab_testing']['optin_fire_id']);
		$optin_fire['args']['ab_testing']['optin_fire_id'] = '0';
		$optin_fire['args']['ab_testing']['start_date'] = '';

		if (isset($ab_optin_fire)) {

			$ab_optin_fire['social']         = unserialize($ab_optin_fire['social']);
			$ab_optin_fire['news_letter']    = unserialize($ab_optin_fire['news_letter']);
			$ab_optin_fire['template']       = unserialize($ab_optin_fire['template']);
			$ab_optin_fire['trigger']        = unserialize($ab_optin_fire['trigger']);
			$ab_optin_fire['style']          = unserialize($ab_optin_fire['style']);
			$ab_optin_fire['args']           = unserialize($ab_optin_fire['args']);

			$ab_optin_fire['args']['ab_testing']['active'] = false;
			$ab_optin_fire['args']['ab_testing']['optin_fire_id'] = '0';
			$ab_optin_fire['args']['ab_testing']['start_date'] = '';
			$nnrobots_optin_fire_db->update_data($ab_optin_fire);
		}

	}

	$nnrobots_optin_fire_db->update_data($optin_fire);
	?>
	<script type="text/javascript">
		window.location = "<?php echo get_admin_url(); ?>admin.php?page=<?php echo self::$dashboard_page; ?>";
	</script>
	<?php
}

// Export data

if (isset($_GET['export_data']) && $_GET['export_data'] == 'true' && check_admin_referer(self::$prefix . 'export_data')) {

	global $wpdb;
	$optin_fire_stats = NNRobots_Stats_OF::getStats($start_date, $end_date, $_GET['optin_fire_id']);
	$optin_fires = $wpdb->get_results("SELECT * FROM `" . NNRobots_Optin_Fire_DB::getTableName() . "`");

	foreach ($optin_fires as $optin_fire) {
		foreach ($optin_fire_stats as $key => $optin_fire_stat) {
			if ($optin_fire->id == $optin_fire_stat['optin_fire_id']) {
				$optin_fire_stats[$key] = array('optin_fire_name' => $optin_fire->name) + $optin_fire_stats[$key];

				$ctr = $optin_fire_stats[$key]['impressions'] != 0 ? round(($optin_fire_stats[$key]['conversions']/$optin_fire_stats[$key]['impressions']) * 100,2) : 0;

				$optin_fire_stats[$key]['click-through-rate'] = $ctr . '%';

			}
		}
	}

	// Unset indexes

	foreach ($optin_fire_stats as $key => $optin_fire_stat) {
		unset($optin_fire_stats[$key]['id']);
		unset($optin_fire_stats[$key]['optin_fire_id']);
	}

	$filename =  self::$prefix . 'stats.csv';
	$export_file = fopen(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/exports/' . $filename, "w");
	fputcsv($export_file, array('Name', 'Date', 'Impressions', 'Conversions', 'Conversion Rate'));

	foreach (array_reverse($optin_fire_stats) as $optin_fire_stat) {
	    fputcsv($export_file, $optin_fire_stat);
	}

	fclose($export_file);

	?>
	<script type="text/javascript">
		window.location = '<?php echo NNROBOTS_OPTIN_FIRE_PLUGIN_URL . '/exports/download.php?filename=' . $filename; ?>';
	</script>
	<?php
}

$ab_start_date = date('m/d/Y');

if (isset($_GET['action']) && $_GET['action'] == 'ab-testing') {

	$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();

	$optin_fire = $nnrobots_optin_fire_db->get_data_from_id($_GET['optin_fire_id']);
	$optin_fire['args'] = unserialize($optin_fire['args']);

	$ab_start_date = date('m/d/Y', strtotime($optin_fire['args']['ab_testing']['start_date']));
}

wp_enqueue_script(self::$prefix . 'stats_js', NNROBOTS_OPTIN_FIRE_PLUGIN_URL . '/admin/js/stats.js', array('jquery'));
wp_localize_script(self::$prefix . 'stats_js', 'nnr_of_stats_data', array(
	'prefix_dash' 		=> self::$prefix_dash,
	'today'				=> date('m/d/Y'),
	'ab_start_date'		=> $ab_start_date,
));

require_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/admin/views/stats.php');