// Created by Kyle Benk kylebenkapps.com

jQuery(document).ready(function($) {

	$("#nnr_plugin_content").fadeIn();

	// Iconpicker

	$('button[role="iconpicker"]').iconpicker().iconpicker('setCols', 10).iconpicker('setRows', 5).iconpicker('setSearch', false);

	// Tabs

	$('#myTab a').click(function (e) {
	  e.preventDefault();
	  $(this).tab('show');
	})
	$('#myTab a:first').tab('show');

	// Color Picker

	$('.color_input').wpColorPicker({
		change: function(event, ui){
			$(this).val(ui.color.toString()).trigger('change');
		},
	});

	// Tooltips

 	$('[data-toggle="tooltip"]').tooltip();

 	// Live Preview

 	$(document).on('change', 'input[data-live-preview="true"], select[data-live-preview="true"], textarea[data-live-preview="true"]', function(){

	 	// Alter the optin fire data inorder to change the preview

	 	var val = $(this).val();

		if ($(this).is(':checkbox')) {
			val = Boolean($(this).prop('checked'));

			if ( $(this).data('property-name') == 'google_fonts' || $(this).data('property-name') == 'heading_google_fonts' ) {
				$('.bfh-selectbox div.bfh-selectbox-options a[data-option="' + $('.bfh-selectbox').data('font') + '"]').trigger('click');
			}
		}

	 	changeOptinProperty(nnr_of_add_edit_data.optin, $(this).data('property-name'), $(this).data('property-parent'), val, '');

 		changePreview();

 	});

 	$(document).on('focusout', 'input[data-live-preview="true"], textarea[data-live-preview="true"]', function(){

	 	var val = $(this).val();

	 	// Checkbox

		if ($(this).is(':checkbox')) {
			val = $(this).prop('checked');
		}

		// Color Picker

		if ($(this).hasClass('wp-color-picker')) {
			return;
		}

 		// Alter the optin fire data inorder to change the preview

	 	changeOptinProperty(nnr_of_add_edit_data.optin, $(this).data('property-name'), $(this).data('property-parent'), val, '');

 		changePreview();
 	});

 	// Bootstrap font picker

 	$('div[data-live-preview="true"]').on('click', 'div.bfh-selectbox-options a', function(){

	 	var input = $(this).closest('.bfh-selectbox').find('input:first');
	 	var val = $(this).data('option');

 		// Alter the optin fire data inorder to change the preview

	 	changeOptinProperty(nnr_of_add_edit_data.optin, input.data('property-name'), input.data('property-parent'), val, '');

 		changePreview();

 	});

 	// List

 	$(document).on('change', '.' + nnr_of_add_edit_data.prefix_dash + 'list-data', function(){

	 	var icons = [];
	 	var texts = [];

	 	$('.' + nnr_of_add_edit_data.prefix_dash + 'list-data').each(function(key, value){

		 	if ( key % 2 == 0 ) {
			 	icons.push($(this).find('input').val());
		 	} else {
		 		texts.push($(this).val());
		 	}

	 	});

	 	nnr_of_add_edit_data.optin.template.args.list.items = [];

	 	$.each(icons, function(key, value){

			nnr_of_add_edit_data.optin.template.args.list.items.push({
			 	'icon': icons[key],
			 	'text': texts[key],
		 	});
	 	});

 		changePreview();
 	});

 	// Social

 	$(document).on('change', '.' + nnr_of_add_edit_data.prefix_dash + 'social-data', function(){

	 	var types = [];
	 	var urls = [];

	 	$('.' + nnr_of_add_edit_data.prefix_dash + 'social-data').each(function(key, value){

		 	if ( key % 2 == 0 ) {
			 	types.push($(this).val());
		 	} else {
		 		urls.push($(this).val());
		 	}

	 	});

	 	nnr_of_add_edit_data.optin.template.args.social.icons = [];

	 	$.each(types, function(key, value){

			nnr_of_add_edit_data.optin.template.args.social.icons.push({
			 	'type': types[key],
			 	'url': urls[key],
		 	});
	 	});

 		changePreview();
 	});

 	// Template

 	$(document).on('change', 'input[name="' + nnr_of_add_edit_data.prefix_dash + 'template-type"]', function(){

	 	$('input:radio[name="' + nnr_of_add_edit_data.prefix_dash + 'template-type"]').val($(this).val());

	 	// Submit form

	 	$('button[name="submit-top"]').trigger('click');
	});

 	/**
 	 * Change the preveiw based on the current settings
 	 *
 	 * @access public
 	 * @return void
 	 */
 	function changePreview(){

	 	if ( $('.' + nnr_of_add_edit_data.prefix_dash + 'live-preview').find('.fa.fa-spinner.fa-spin.fa-5x').length != 0 ) {
	 		return;
	 	}

	 	$('.' + nnr_of_add_edit_data.prefix_dash + 'live-preview').append('<div class="fa fa-spinner fa-spin fa-5x"></div>');

	 	$.post(ajaxurl, {'action': 'nnr_of_live_preview', 'optin': nnr_of_add_edit_data.optin}, function(response) {

			$('.' + nnr_of_add_edit_data.prefix_dash + 'live-preview').find('.fa').remove();
			$('.' + nnr_of_add_edit_data.prefix_dash + 'live-preview').html(response);
			$('.' + nnr_of_add_edit_data.prefix_dash + 'live-preview').attr('data-type', nnr_of_add_edit_data.optin.type);

			addStyling($('.' + nnr_of_add_edit_data.prefix_dash + 'wrap'), false, nnr_of_add_edit_data.optin);

			if ($('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').data('type') == '2' ||
				$('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').data('type') == '4' ||
				$('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').data('type') == '5') {

			    if ($('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').data('type') == '5') {
				    $('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').css('max-width', '250px');
				    $('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').css('margin', '0 auto');
			    } else {
				   	$('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').css('max-width', '700px');
				   	$('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').css('display', 'table');
				   	$('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').css('position', 'relative');
				   	$('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').css('margin', '0 auto');
			    }

		    }

		    $('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').show();
		    $('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').find('.' + nnr_of_add_edit_data.prefix_dash + 'container').show();
			$('.' + nnr_of_add_edit_data.prefix_dash + 'wrap').find('.' + nnr_of_add_edit_data.prefix_dash + 'container').css('position', 'static');

		});
 	}

 	/**
 	 * Change the live preview optin in order to generate a new preview
 	 *
 	 * @access public
 	 * @param mixed optin
 	 * @param mixed property_name
 	 * @param mixed property_parent
 	 * @param mixed val
 	 * @param mixed parent_prop
 	 * @return void
 	 */
 	function changeOptinProperty(optin, property_name, property_parent, val, parent_prop) {

	 	// Loop through all properties and find the matching one

	    for (var prop in optin) {

		    // List

		    if ( prop == 'icon' && property_parent == 'list') {
			    console.log('yes');
		    }

		    // Check if the property name and property parent match

	        if ( prop == property_name && ( property_parent == '' || property_parent == parent_prop ) ) {
	            optin[prop] = val;
	        }

	        // If this property is an object or array then loop through it to find the matching property

	        if ( optin[prop] instanceof Object || optin[prop] instanceof Array ) {
		    	changeOptinProperty(optin[prop], property_name, property_parent, val, prop);
	        }
	    }
 	}

 	// Real-time validation for required fields

	$("#" + nnr_of_add_edit_data.prefix_dash + "name").keyup(function(){
		if ($(this).val() != '') {
			$(this).parent('div').parent('div').removeClass('has-error');
			$(this).parent('div').find('span.glyphicon-remove').remove();
			$(this).parent('div').find('i').show();
		} else {
			$(this).parent('div').parent('div').addClass('has-error');
			$(this).parent('div').find('i').hide();
			$(this).parent('div').append('<span class="glyphicon glyphicon-remove form-control-feedback"></span>');
		}
	});

	// Form submit preventDefault() if required values are not satisfied

	$("#" + nnr_of_add_edit_data.prefix_dash + "form").submit(function(e){

		if ($("#" + nnr_of_add_edit_data.prefix_dash + "name").val() == '') {
			e.preventDefault();
		}
	});

	// Type

	$("." + nnr_of_add_edit_data.prefix_dash + "type").hide();
	$("." + nnr_of_add_edit_data.prefix_dash + "type-" + $("input[name='" + nnr_of_add_edit_data.prefix_dash + "type']").val()).show();

	// Template settings

	if ($("input[name='" + nnr_of_add_edit_data.prefix_dash + "type']").val() == '2' ||
		$("input[name='" + nnr_of_add_edit_data.prefix_dash + "type']").val() == '4' ||
		$("input[name='" + nnr_of_add_edit_data.prefix_dash + "type']").val() == '5') {

		$("." + nnr_of_add_edit_data.prefix_dash + "template").hide();
		$("." + nnr_of_add_edit_data.prefix_dash + "template-" + $("input[name='" + nnr_of_add_edit_data.prefix_dash + "template-type']:checked").val()).show();

	 	$("input[name='" + nnr_of_add_edit_data.prefix_dash + "template-type']").change(function() {

	 		$("." + nnr_of_add_edit_data.prefix_dash + "template").hide();
	 		$("." + nnr_of_add_edit_data.prefix_dash + "template-" + $(this).val()).show();

		});

	}

	// Newsletter settings hide and show

	$('.' + nnr_of_add_edit_data.prefix_dash + 'news-letter').hide();
	$("." + nnr_of_add_edit_data.prefix_dash + "news-letter-" + $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-type').val()).show();

  	$('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-type').change(function() {

	  	// Show and Hide Newsletter settings

 		$('.' + nnr_of_add_edit_data.prefix_dash + 'news-letter').hide();
 		$("." + nnr_of_add_edit_data.prefix_dash + "news-letter-" + $(this).val()).show();

	});

	// Background Type

	$("." + nnr_of_add_edit_data.prefix_dash + "background-type").hide();
	$("." + nnr_of_add_edit_data.prefix_dash + "background-type-" + $("select[name='" + nnr_of_add_edit_data.prefix_dash + "background-type']").val()).show();

 	$("select[name='" + nnr_of_add_edit_data.prefix_dash + "background-type']").change(function() {
 		$("." + nnr_of_add_edit_data.prefix_dash + "background-type").hide();
 		$("." + nnr_of_add_edit_data.prefix_dash + "background-type-" + $(this).val()).show();
	});

	// Placement Type

	$("." + nnr_of_add_edit_data.prefix_dash + "placement").hide();
	$("." + nnr_of_add_edit_data.prefix_dash + "placement-" + $("select[name='" + nnr_of_add_edit_data.prefix_dash + "args-placement-type']").val()).show();

 	$("select[name='" + nnr_of_add_edit_data.prefix_dash + "args-placement-type']").change(function() {
 		$("." + nnr_of_add_edit_data.prefix_dash + "placement").hide();
 		$("." + nnr_of_add_edit_data.prefix_dash + "placement-" + $(this).val()).show();
	});

	// Call to Action Type

	$("." + nnr_of_add_edit_data.prefix_dash + "template-args-call-to-action").hide();
	$("." + nnr_of_add_edit_data.prefix_dash + "template-args-call-to-action-" + $("input[name='" + nnr_of_add_edit_data.prefix_dash + "template-args-call-to-action']:checked").val()).show();

 	$("input[name='" + nnr_of_add_edit_data.prefix_dash + "template-args-call-to-action']").change(function() {
 		$("." + nnr_of_add_edit_data.prefix_dash + "template-args-call-to-action").hide();
 		$("." + nnr_of_add_edit_data.prefix_dash + "template-args-call-to-action-" + $(this).val()).show();
	});

	// Success Action

	$("." + nnr_of_add_edit_data.prefix_dash + "news-letter-success-action").hide();
	$("." + nnr_of_add_edit_data.prefix_dash + "news-letter-success-action-" + $("#" + nnr_of_add_edit_data.prefix_dash + "news-letter-success-action").val()).show();

 	$("#" + nnr_of_add_edit_data.prefix_dash + "news-letter-success-action").change(function() {
 		$("." + nnr_of_add_edit_data.prefix_dash + "news-letter-success-action").hide();
 		$("." + nnr_of_add_edit_data.prefix_dash + "news-letter-success-action-" + $(this).val()).show();

 	});

	// Trigger Type

	$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-type").hide();
	$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-type-" + $("select[name='" + nnr_of_add_edit_data.prefix_dash + "trigger-args-type']").val()).show();

 	$("select[name='" + nnr_of_add_edit_data.prefix_dash + "trigger-args-type']").change(function() {
 		$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-type").hide();
 		$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-type-" + $(this).val()).show();
	});

	// Display manually

	$("." + nnr_of_add_edit_data.prefix_dash + "trigger").hide();
	$("." + nnr_of_add_edit_data.prefix_dash + "trigger-manual-display").hide();

	if (!$('input[name="' + nnr_of_add_edit_data.prefix_dash + 'trigger-manual-display"]').prop('checked')) {
		$("." + nnr_of_add_edit_data.prefix_dash + "trigger").show();
	} else {
		$("." + nnr_of_add_edit_data.prefix_dash + "trigger-manual-display").show();
	}

	// Dont show again

	$("." + nnr_of_add_edit_data.prefix_dash + "dont-show-again").show();

	if ( ($("input[name='" + nnr_of_add_edit_data.prefix_dash + "type']").val() == '1' || $("input[name='" + nnr_of_add_edit_data.prefix_dash + "type']").val() == '3' ) &&
		  !$("input[name='" + nnr_of_add_edit_data.prefix_dash + "close-button']").prop('checked')) {

		$("." + nnr_of_add_edit_data.prefix_dash + "dont-show-again").hide();
	}

	$("input[name='" + nnr_of_add_edit_data.prefix_dash + "close-button']").change(function() {

		$("." + nnr_of_add_edit_data.prefix_dash + "dont-show-again").show();

		if ( ($("input[name='" + nnr_of_add_edit_data.prefix_dash + "type']").val() == '1' || $("input[name='" + nnr_of_add_edit_data.prefix_dash + "type']").val() == '3' ) &&
		  	!$(this).prop('checked')) {

			$("." + nnr_of_add_edit_data.prefix_dash + "dont-show-again").hide();
		}
	});

 	$('input[name="' + nnr_of_add_edit_data.prefix_dash + 'trigger-manual-display"]').change(function() {

 		$("." + nnr_of_add_edit_data.prefix_dash + "trigger").hide();
 		$("." + nnr_of_add_edit_data.prefix_dash + "trigger-manual-display").hide();

		if (!$(this).prop('checked')) {
			$("." + nnr_of_add_edit_data.prefix_dash + "trigger").show();

			for (var i = 0; i < nnr_of_add_edit_data.post_types.length; i++) {
				$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-div-' + nnr_of_add_edit_data.post_types[i]).hide();
			}
			$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-div').hide();
			$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-tag-div').hide();


		  	if( $('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val() == 'category' ) {
			  	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-div').show();
		  	} else if($('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val() == 'tag') {
			  	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-tag-div').show();
		  	} else {
			  	for (var i = 0; i < nnr_of_add_edit_data.post_types.length; i++) {
			  		if($('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val() == nnr_of_add_edit_data.post_types[i]) {
				  		$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-div-' + nnr_of_add_edit_data.post_types[i]).show();
				  	}
				}
		  	}
		} else {
			$("." + nnr_of_add_edit_data.prefix_dash + "trigger-manual-display").show();
		}
	});

	// Category

	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-all').click(function() {
		if($(this).is(':checked')) {
			$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-id-div').hide();
		}else{
			$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-id-div').show();
		}
	});

	if($('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-all').is(':checked')) {
		$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-id-div').hide();
	}

	// User Roles

	$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-users").hide();
	$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-users-" + $("#" + nnr_of_add_edit_data.prefix_dash + "trigger-args-users").val()).show();

 	$("#" + nnr_of_add_edit_data.prefix_dash + "trigger-args-users").change(function() {
 		$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-users").hide();
 		$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-users-" + $(this).val()).show();

 	});

 	// URL Referrer

	$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-referrer").hide();
	$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-referrer-" + $("#" + nnr_of_add_edit_data.prefix_dash + "trigger-args-referrer-type").val()).show();

 	$("#" + nnr_of_add_edit_data.prefix_dash + "trigger-args-referrer-type").change(function() {
 		$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-referrer").hide();
 		$("." + nnr_of_add_edit_data.prefix_dash + "trigger-args-referrer-" + $(this).val()).show();

 	});

 	// Link button

 	$("#" + nnr_of_add_edit_data.prefix_dash + "template-args-link-type").change(function(){

	 	$("." + nnr_of_add_edit_data.prefix_dash + "template-args-link-button-color").hide();

 		if ($(this).val() == 'button') {
 			$("." + nnr_of_add_edit_data.prefix_dash + "template-args-link-button-color").show();
 		}

 	});

 	$("." + nnr_of_add_edit_data.prefix_dash + "template-args-link-button-color").hide();

	if ($("#" + nnr_of_add_edit_data.prefix_dash + "template-args-link-type").val() == 'button') {
		$("." + nnr_of_add_edit_data.prefix_dash + "template-args-link-button-color").show();
	}

	// Enable and Disable Locations based of Full Height / Width box

	$("input[name='" + nnr_of_add_edit_data.prefix_dash + "full']").change(function(){

		if ($(this).val() == 'yes') {

			$("." + nnr_of_add_edit_data.prefix_dash + "push-pull").show();

			$("." + nnr_of_add_edit_data.prefix_dash + "location-button").removeClass('active');
			$("input[name='" + nnr_of_add_edit_data.prefix_dash + "location']").prop('checked', false);

			$("#" + nnr_of_add_edit_data.prefix_dash + "location-2").parent('div').addClass('active');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-2").prop('checked', true);
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-2").trigger('change');

			$("#" + nnr_of_add_edit_data.prefix_dash + "location-1").parent('div').addClass('disabled');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-3").parent('div').addClass('disabled');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-7").parent('div').addClass('disabled');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-9").parent('div').addClass('disabled');

			$("#" + nnr_of_add_edit_data.prefix_dash + "location-1").parent('div').css('border', 'none');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-3").parent('div').css('border', 'none');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-7").parent('div').css('border', 'none');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-9").parent('div').css('border', 'none');

		} else {

			$("." + nnr_of_add_edit_data.prefix_dash + "push-pull").hide();

			$("#" + nnr_of_add_edit_data.prefix_dash + "location-1").parent('div').removeClass('disabled');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-3").parent('div').removeClass('disabled');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-7").parent('div').removeClass('disabled');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-9").parent('div').removeClass('disabled');

			$("#" + nnr_of_add_edit_data.prefix_dash + "location-1").parent('div').css('border', '1px solid #ccc');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-3").parent('div').css('border', '1px solid #ccc');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-7").parent('div').css('border', '1px solid #ccc');
			$("#" + nnr_of_add_edit_data.prefix_dash + "location-9").parent('div').css('border', '1px solid #ccc');

		}

	});

	if ($("input[name='" + nnr_of_add_edit_data.prefix_dash + "full']:checked").val() == 'yes') {

		$("." + nnr_of_add_edit_data.prefix_dash + "push-pull").show();

		$("#" + nnr_of_add_edit_data.prefix_dash + "location-1").parent('div').addClass('disabled');
		$("#" + nnr_of_add_edit_data.prefix_dash + "location-3").parent('div').addClass('disabled');
		$("#" + nnr_of_add_edit_data.prefix_dash + "location-7").parent('div').addClass('disabled');
		$("#" + nnr_of_add_edit_data.prefix_dash + "location-9").parent('div').addClass('disabled');

		$("#" + nnr_of_add_edit_data.prefix_dash + "location-1").parent('div').css('border', 'none');
		$("#" + nnr_of_add_edit_data.prefix_dash + "location-3").parent('div').css('border', 'none');
		$("#" + nnr_of_add_edit_data.prefix_dash + "location-7").parent('div').css('border', 'none');
		$("#" + nnr_of_add_edit_data.prefix_dash + "location-9").parent('div').css('border', 'none');

	} else {

		$("." + nnr_of_add_edit_data.prefix_dash + "push-pull").hide();

	}

	// Display On

  	if (typeof(nnr_of_add_edit_data.post_types) != "undefined" && nnr_of_add_edit_data.post_types !== null) {

	  	// Trigger

		$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').change(function(){
			for (var i = 0; i < nnr_of_add_edit_data.post_types.length; i++) {
				$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-div-' + nnr_of_add_edit_data.post_types[i]).hide();
			}
			$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-div').hide();
			$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-tag-div').hide();


		  	if( $(this).val() == 'category' ) {
			  	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-div').show();
		  	} else if($(this).val() == 'tag') {
			  	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-tag-div').show();
		  	} else {
			  	for (var i = 0; i < nnr_of_add_edit_data.post_types.length; i++) {
			  		if($(this).val() == nnr_of_add_edit_data.post_types[i]) {
				  		$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-div-' + nnr_of_add_edit_data.post_types[i]).show();
				  	}
				}
		  	}
		});

		for (var i = 0; i < nnr_of_add_edit_data.post_types.length; i++) {
			$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-div-' + nnr_of_add_edit_data.post_types[i]).hide();
		}

		$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-div').hide();
		$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-tag-div').hide();

		if ($('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val() == 'category') {
		  	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-div').show();
	  	}

	  	else if ($('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val() == 'tag') {
		  	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-tag-div').show();
	  	}

	  	else {

		  	for (var i = 0; i < nnr_of_add_edit_data.post_types.length; i++) {
		  		if ($('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val() == nnr_of_add_edit_data.post_types[i]) {
			  		$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-div-' + nnr_of_add_edit_data.post_types[i]).show();
			  	}
			}
	  	}

	  	// Post Types

	  	for (var i = 0; i < nnr_of_add_edit_data.post_types.length; i++) {

			$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-all-' + nnr_of_add_edit_data.post_types[i]).click(function() {
				if($(this).is(':checked')) {
					$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-id-div-' + $(this).attr('data-post')).hide();
				}else{
					$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-id-div-' + $(this).attr('data-post')).show();
				}
			});

			if($('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-all-' + nnr_of_add_edit_data.post_types[i]).is(':checked')) {
				$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-id-div-' + nnr_of_add_edit_data.post_types[i]).hide();
			}
		}
  	}

  	// Google Fonts Toogle

  	$('#' + nnr_of_add_edit_data.prefix_dash + 'google-font').hide();
  	$('#' + nnr_of_add_edit_data.prefix_dash + 'font-family').hide();

	if ($('#' + nnr_of_add_edit_data.prefix_dash + 'google-fonts').prop('checked')) {

		$('#' + nnr_of_add_edit_data.prefix_dash + 'google-font').insertAfter($('#' + nnr_of_add_edit_data.prefix_dash + 'font-family'));
		$('#' + nnr_of_add_edit_data.prefix_dash + 'google-font').show();

	} else {

		$('#' + nnr_of_add_edit_data.prefix_dash + 'font-family').insertAfter($('#' + nnr_of_add_edit_data.prefix_dash + 'google-font'));
		$('#' + nnr_of_add_edit_data.prefix_dash + 'font-family').show();
	}

	$('#' + nnr_of_add_edit_data.prefix_dash + 'google-fonts').change(function(){

	  	$('#' + nnr_of_add_edit_data.prefix_dash + 'google-font').hide();
	  	$('#' + nnr_of_add_edit_data.prefix_dash + 'font-family').hide();

  		if ($(this).prop('checked')) {

  			$('#' + nnr_of_add_edit_data.prefix_dash + 'google-font').insertAfter($('#' + nnr_of_add_edit_data.prefix_dash + 'font-family'));
  			$('#' + nnr_of_add_edit_data.prefix_dash + 'google-font').show();

  		} else {

  			$('#' + nnr_of_add_edit_data.prefix_dash + 'font-family').insertAfter($('#' + nnr_of_add_edit_data.prefix_dash + 'google-font'));
  			$('#' + nnr_of_add_edit_data.prefix_dash + 'font-family').show();
  		}
  	});

	$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-google-font').hide();
	$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-font-family').hide();

	if ($('#' + nnr_of_add_edit_data.prefix_dash + 'heading-google-fonts').prop('checked')) {

		$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-google-font').insertAfter($('#' + nnr_of_add_edit_data.prefix_dash + 'heading-font-family'));
		$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-google-font').show();

	} else {

		$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-font-family').insertAfter($('#' + nnr_of_add_edit_data.prefix_dash + 'heading-google-font'));
		$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-font-family').show();
	}


	$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-google-fonts').change(function(){

	  	$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-google-font').hide();
	  	$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-font-family').hide();

  		if ($(this).prop('checked')) {

  			$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-google-font').insertAfter($('#' + nnr_of_add_edit_data.prefix_dash + 'heading-font-family'));
  			$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-google-font').show();

  		} else {

  			$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-font-family').insertAfter($('#' + nnr_of_add_edit_data.prefix_dash + 'heading-google-font'));
  			$('#' + nnr_of_add_edit_data.prefix_dash + 'heading-font-family').show();
  		}
  	});

	// Image

	$('#' + nnr_of_add_edit_data.prefix_dash + 'image-btn').click(function(e) {
	    e.preventDefault();

		var custom_uploader = wp.media()

	    .on('select', function() {
	        var attachment = custom_uploader.state().get('selection').first().toJSON();
	        $('#' + nnr_of_add_edit_data.prefix_dash + 'image-show').css('background-image', 'url(' + attachment.url + ')');
	        $('#' + nnr_of_add_edit_data.prefix_dash + 'image').val(attachment.id).trigger('change');
	    })
	    .open();
	});

	$('#' + nnr_of_add_edit_data.prefix_dash + 'image-btn-remove').click(function(){
		$('#' + nnr_of_add_edit_data.prefix_dash + 'image-show').css('background-image', '');
	    $('#' + nnr_of_add_edit_data.prefix_dash + 'image').val('').trigger('change');
	});

	// Clickable Image

	$('#' + nnr_of_add_edit_data.prefix_dash + 'clickable-image-btn').click(function(e) {
	    e.preventDefault();

		var custom_uploader = wp.media()

	    .on('select', function() {
	        var attachment = custom_uploader.state().get('selection').first().toJSON();
	        $('#' + nnr_of_add_edit_data.prefix_dash + 'clickable-image-show').css('background-image', 'url(' + attachment.url + ')');
	        $('#' + nnr_of_add_edit_data.prefix_dash + 'template-args-clickable-image').val(attachment.id).trigger('change');
	    })
	    .open();
	});

	$('#' + nnr_of_add_edit_data.prefix_dash + 'clickable-image-btn-remove').click(function(){
		$('#' + nnr_of_add_edit_data.prefix_dash + 'clickable-image-show').css('background-image', '');
	    $('#' + nnr_of_add_edit_data.prefix_dash + 'template-args-clickable-image').val('').trigger('change');
	});

	// Background Image

	$('#' + nnr_of_add_edit_data.prefix_dash + 'background-image-btn').click(function(e) {
	    e.preventDefault();

		var custom_uploader = wp.media()

	    .on('select', function() {
	        var attachment = custom_uploader.state().get('selection').first().toJSON();
	        $('#' + nnr_of_add_edit_data.prefix_dash + 'background-image-show').css('background-image', 'url(' + attachment.url + ')');
	        $('#' + nnr_of_add_edit_data.prefix_dash + 'background-image').val(attachment.id).trigger('change');
	    })
	    .open();
	});

	$('#' + nnr_of_add_edit_data.prefix_dash + 'background-image-btn-remove').click(function(){
		$('#' + nnr_of_add_edit_data.prefix_dash + 'background-image-show').css('background-image', '');
	    $('#' + nnr_of_add_edit_data.prefix_dash + 'background-image').val('').trigger('change');
	});

	// Datetimepicker

	$('#' + nnr_of_add_edit_data.prefix_dash + 'start-datepicker').datetimepicker({
        format: 'MM/DD/YYYY'
    });

	$('#' + nnr_of_add_edit_data.prefix_dash + 'end-datepicker').datetimepicker({
        format: 'MM/DD/YYYY'
    });

	$('#' + nnr_of_add_edit_data.prefix_dash + 'end-datepicker')
		.data("DateTimePicker")
		.minDate( $('#' + nnr_of_add_edit_data.prefix_dash + 'start-datepicker').data("DateTimePicker").date() );

	$('#' + nnr_of_add_edit_data.prefix_dash + 'start-datepicker').on("dp.change",function (e) {
       $('#' + nnr_of_add_edit_data.prefix_dash + 'end-datepicker').data("DateTimePicker").minDate(e.date);
    });

    $('#' + nnr_of_add_edit_data.prefix_dash + 'end-datepicker').on("dp.change",function (e) {
       $('#' + nnr_of_add_edit_data.prefix_dash + 'start-datepicker').data("DateTimePicker").maxDate(e.date);
    });

    // Close button settings

	$('.' + nnr_of_add_edit_data.prefix_dash + 'close-button-on').hide();
	$('.' + nnr_of_add_edit_data.prefix_dash + 'close-button-off').hide();

	if ( $('#' + nnr_of_add_edit_data.prefix_dash + 'type').val() == '1' || $('#' + nnr_of_add_edit_data.prefix_dash + 'type').val() == '3' ) {
		if ($('#' + nnr_of_add_edit_data.prefix_dash + 'close-button').prop('checked')) {
			$('.' + nnr_of_add_edit_data.prefix_dash + 'close-button-on').show();
		} else {
			$('.' + nnr_of_add_edit_data.prefix_dash + 'close-button-off').show();
		}
	}

	$('#' + nnr_of_add_edit_data.prefix_dash + 'close-button').change(function(){

		if ( $('#' + nnr_of_add_edit_data.prefix_dash + 'type').val() == '1' || $('#' + nnr_of_add_edit_data.prefix_dash + 'type').val() == '3' ) {
			$('.' + nnr_of_add_edit_data.prefix_dash + 'close-button-on').hide();
			$('.' + nnr_of_add_edit_data.prefix_dash + 'close-button-off').hide();

			if ($(this).prop('checked')) {
				$('.' + nnr_of_add_edit_data.prefix_dash + 'close-button-on').show();
			} else {
				$('.' + nnr_of_add_edit_data.prefix_dash + 'close-button-off').show();
			}
		}
	});

    // Save all settings

	$('.' + nnr_of_add_edit_data.prefix_dash + 'news-letter-set-default').click(function(e){

		$(this).append('<i style="margin-left:10px;" class="fa fa-spinner fa-spin"></i>');

		e.preventDefault();

		$.post(ajaxurl, {
			'action': 'nnr_of_save_default_newsletter',
			'type': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-type').val(),
			'mailchimp_optin': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-mailchimp-optin').prop('checked'),
			'mailchimp_api_key': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-mailchimp-api-key').val(),
			'mailchimp_list': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-mailchimp-list').val(),
			'aweber_consumer_key': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-aweber-consumer-key').val(),
			'aweber_consumer_secret': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-aweber-consumer-secret').val(),
			'aweber_access_key': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-aweber-access-key').val(),
			'aweber_access_secret': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-aweber-access-secret').val(),
			'aweber_list_id': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-aweber-list-id').val(),
			'getresponse_api_key': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-getresponse-api-key').val(),
			'getresponse_campaign': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-getresponse-campaign').val(),
			'campaignmonitor_api_key': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-campaignmonitor-api-key').val(),
			'campaignmonitor_client': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-campaignmonitor-client').val(),
			'campaignmonitor_list': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-campaignmonitor-list').val(),
			'madmimi_username': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-madmimi-username').val(),
			'madmimi_api_key': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-madmimi-api-key').val(),
			'madmimi_list': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-madmimi-list').val(),
			'infusionsoft_app_id': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-infusionsoft-app-id').val(),
			'infusionsoft_api_key': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-infusionsoft-api-key').val(),
			'infusionsoft_list': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-infusionsoft-list').val(),
			'feedburner_id': $('#' + nnr_of_add_edit_data.prefix_dash + 'news-letter-feedburner-id').val(),}, function(response) {

				$('.' + nnr_of_add_edit_data.prefix_dash + 'news-letter-set-default .fa-spin').remove();

				$('.' + nnr_of_add_edit_data.prefix_dash + 'news-letter-set-default').append('<i style="color:green;padding-left:10px;" class="fa fa-check"></i>');

				$('.' + nnr_of_add_edit_data.prefix_dash + 'news-letter-set-default .fa-check').fadeOut(2000, function() {
					$(this).remove();
				});

				console.log(response);

		});
	});

	// Async functions

	setTimeout(function() {

	  	// Create an easy interface for selecting categories

		$.post(nnr_of_add_edit_data.ajaxurl, {'action': 'nnr_of_get_categories'}, function(response) {

			response = $.parseJSON(response);

			// Create an easy interface for selecting tags

		  	var tag_options = [];

		  	$.each(response, function( index, value ) {
			  	tag_options.push( {id: value.term_id, name: value.name} );
			});

		  	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-category-id').selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: tag_options,
		  	});
		});

	   	// Create an easy interface for selecting tags

		$.post(nnr_of_add_edit_data.ajaxurl, {'action': 'nnr_of_get_tags'}, function(response) {

			response = $.parseJSON(response);

			// Create an easy interface for selecting tags

		  	var tag_options = [];

		  	$.each(response, function( index, value ) {
			  	tag_options.push( {id: value.term_id, name: value.name} );
			});

		  	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-tag-id').selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: tag_options,
		  	});

		  	$('#' + nnr_of_add_edit_data.prefix_dash + 'recent-posts-tag').selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: tag_options,
		  	});
		});

		if ($('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val() != 'site' ||
			$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val() != 'category' ||
			$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val() != 'tag' ||
			$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val() != 'archive') {

			$.post(nnr_of_add_edit_data.ajaxurl, {'action': 'nnr_of_get_posts', 'post_type': $('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val()}, function(response) {

				response = $.parseJSON(response);

				// Create an easy interface for selecting tags

			  	var post_options = [];

			  	$.each(response, function( index, value ) {
				  	post_options.push({id: value.ID, name: value.post_title});

				});

				$('.' + nnr_of_add_edit_data.prefix_dash + 'trigger-id-' + $('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val()).selectize({
				  	plugins: ['remove_button'],
				  	valueField: 'id',
					labelField: 'name',
					searchField: 'name',
				  	options: post_options,
			  	});
			});

		}

	} ,1);

	// Upon Display On setting change refresh the selectize options if needed

	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').change(function() {

		if ($(this).val() != 'site' || $(this).val() != 'category' || $(this).val() != 'tag' || $(this).val() != 'archive') {

			$.post(nnr_of_add_edit_data.ajaxurl, {'action': 'nnr_of_get_posts', 'post_type': $(this).val()}, function(response) {

				response = $.parseJSON(response);

				// Create an easy interface for selecting tags

			  	var post_options = [];

			  	$.each(response, function( index, value ) {
				  	post_options.push({id: value.ID, name: value.post_title});

				});

				if (!$('.' + nnr_of_add_edit_data.prefix_dash + 'trigger-id-' + $('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val()).hasClass('selectized')) {
					$('.' + nnr_of_add_edit_data.prefix_dash + 'trigger-id-' + $('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on').val()).selectize({
					  	plugins: ['remove_button'],
					  	valueField: 'id',
						labelField: 'name',
						searchField: 'name',
					  	options: post_options,
				  	});
				}
			});
		}
	});

	// Populate all the exlucde settings with thier respective posts

	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-display-on option').each(function() {

		$.post(nnr_of_add_edit_data.ajaxurl, {'action': 'nnr_of_get_posts', 'post_type': $(this).val()}, function(response) {

			response = $.parseJSON(response);

			// Create an easy interface for selecting tags

		  	var post_options = [];
		  	var post_type = '';

		  	$.each(response, function( index, value ) {
			  	post_options.push({id: value.ID, name: value.post_title});
			  	post_type = value.post_type;
			});

			$('.' + nnr_of_add_edit_data.prefix_dash + 'trigger-exclude-' + post_type).selectize({
			  	plugins: ['remove_button'],
			  	valueField: 'id',
				labelField: 'name',
				searchField: 'name',
			  	options: post_options,
		  	});

		});
	});

	// Add selectize to the Referrer Domains

	var referrer_options = [
		{id: 't.co'},
		{id: 'www.facebook.com'},
		{id: 'plus.url.google.com'},
		{id: 'www.linkedin.com'},
	];

	var temp_referrer_options = $('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-args-referrer').attr('data-urls').split(',');

	$.each(temp_referrer_options, function( index, value ) {
	  	referrer_options.push({id: value});
	});

	$('#' + nnr_of_add_edit_data.prefix_dash + 'trigger-args-referrer').selectize({
		plugins: ['remove_button'],
		create: true,
		valueField: 'id',
		labelField: 'id',
		searchField: 'id',
		options: referrer_options,
	});

	/**
	 * Get the url parameters
	 *
	 * @access public
	 * @param mixed sParam
	 * @return void
	 */
	function getUrlParameter(sParam) {
	    var sPageURL = window.location.search.substring(1);
	    var sURLVariables = sPageURL.split('&');
	    for (var i = 0; i < sURLVariables.length; i++)
	    {
	        var sParameterName = sURLVariables[i].split('=');
	        if (sParameterName[0] == sParam)
	        {
	            return sParameterName[1];
	        }
	    }
	}
});