<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

//if ( !class_exists('NNRobots_Optin_Fire_Functions') ) :

add_action( 'the_content',								array('NNRobots_Optin_Fire_Functions', 'display_inline'));
add_action( 'wp_footer',								array('NNRobots_Optin_Fire_Functions', 'display'));

add_action( 'wp_ajax_nnr_of_get_styling_data', 			array('NNRobots_Optin_Fire_Functions', 'get_styling_data'));
add_action( 'wp_ajax_nopriv_nnr_of_get_styling_data', 	array('NNRobots_Optin_Fire_Functions', 'get_styling_data'));

// AJAX call to get all tags and custom posts

add_action( 'wp_ajax_nnr_of_set_close_cookie', 			array('NNRobots_Optin_Fire_Functions', 'set_close_cookie'));
add_action( 'wp_ajax_nopriv_nnr_of_set_close_cookie', 	array('NNRobots_Optin_Fire_Functions', 'set_close_cookie'));

/**
 *
 * Main class used to display the optin fire on the website and display backend options
 *
 * @since 1.0.0
 */
class NNRobots_Optin_Fire_Functions {

	/**
	 * Hook function to wp_footer to display popup on website
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function display() {

		// Include DB file for accessing optins

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/admin/model/db.php');

		// Define all needed global variables

		global $wpdb;
		global $post;
		global $cat;

		// Define all display optin type variables

		$displayed_banner 	= null;
		$displayed_popup 	= null;
		$displayed_flyout 	= null;

		$data = NNRobots_Optin_Fire_DB::get_by_type(array(1,2,3));

        // Get all post types that are public

		$post_types = get_post_types(array('public' => true));
		// Post Types

		if (is_singular()) {

			foreach ($data as $val) {

				$args         = $val['args'];
	        	$template     = $val['template'];
        		$trigger      = $val['trigger'];
        		$news_letter  = $val['news_letter'];

        		// Check that conditions are true

        		if (!self::check_conditions($val, $template, $args, $trigger, $displayed_banner, $displayed_flyout, $displayed_popup)) {
	        		continue;
        		}

        		$post_ids = array();

        		if (isset($trigger[$post->post_type]['id'])) {
	        		$post_ids = explode(',', $trigger[$post->post_type]['id']);
        		}

	    		// Check if post types match

	    		if (isset($trigger['display_on']) && $trigger['display_on'] != $post->post_type) {
		    		continue;
	    		}

        		// ID

        		if (isset($trigger[$post->post_type]['all']) &&
        			!$trigger[$post->post_type]['all'] &&
	    			in_array($post->ID, $post_ids)) {

	        		echo self::generate_code($val, $news_letter);

		        	if ( $val['type'] == '1' ) {
						$displayed_banner = $val;
	        		} else if ( $val['type'] == '2' ) {
						$displayed_popup = $val;
	        		} else if ( $val['type'] == '3' ) {
						$displayed_flyout = $val;
	        		}

        		}
	        }

			foreach ($data as $val) {

				$args         = $val['args'];
	        	$template     = $val['template'];
        		$trigger      = $val['trigger'];
        		$news_letter  = $val['news_letter'];

        		// Check that conditions are true

        		if (!self::check_conditions($val, $template, $args, $trigger, $displayed_banner, $displayed_flyout, $displayed_popup)) {
	        		continue;
        		}

        		$post_ids = array();

        		if (isset($trigger[$post->post_type]['id'])) {
	        		$post_ids = explode(',', $trigger[$post->post_type]['id']);
        		}

        		// Check if post types match

	    		if (isset($trigger['display_on']) && $trigger['display_on'] != $post->post_type) {
		    		continue;
	    		}

		    	// Tag ID

		    	$tags = explode(',', $trigger['tag']['id']);

        		if ($trigger['display_on'] == 'tag' &&
        			has_tag($tags,$post->ID)) {

	        		echo self::generate_code($val, $news_letter);

	        		if ( $val['type'] == '1' ) {
						$displayed_banner = $val;
	        		} else if ( $val['type'] == '2' ) {
						$displayed_popup = $val;
	        		} else if ( $val['type'] == '3' ) {
						$displayed_flyout = $val;
	        		}

        		}

        		// Category ID

        		if ($trigger['display_on'] == 'category' &&
        			isset($trigger['category']['all']) &&
        			!$trigger['category']['all'] &&
        			in_category($category_ids, $post->ID)) {

	        		echo self::generate_code($val, $news_letter);

	        		if ( $val['type'] == '1' ) {
						$displayed_banner = $val;
	        		} else if ( $val['type'] == '2' ) {
						$displayed_popup = $val;
	        		} else if ( $val['type'] == '3' ) {
						$displayed_flyout = $val;
	        		}

        		}

        		// All

        		if ($trigger['display_on'] != 'category' &&
        			$trigger['display_on'] != 'tag' &&
        			isset($trigger[$post->post_type]['all']) &&
        			$trigger[$post->post_type]['all']) {

	        		echo self::generate_code($val, $news_letter);

	        		if ( $val['type'] == '1' ) {
						$displayed_banner = $val;
	        		} else if ( $val['type'] == '2' ) {
						$displayed_popup = $val;
	        		} else if ( $val['type'] == '3' ) {
						$displayed_flyout = $val;
	        		}

        		}
	        }
		}

        // Tag

        if (is_tag()) {
	        foreach ($data as $val) {

		        $args         = $val['args'];
	        	$template     = $val['template'];
        		$trigger      = $val['trigger'];
        		$news_letter  = $val['news_letter'];

        		// Check that conditions are true

        		if (!self::check_conditions($val, $template, $args, $trigger, $displayed_banner, $displayed_flyout, $displayed_popup)) {
	        		continue;
        		}

        		$tags = explode(',', $trigger['tag']['id']);

        		if ($trigger['display_on'] == 'tag' &&
        			is_tag($tags)) {

	        		echo self::generate_code($val, $news_letter);

	        		if ( $val['type'] == '1' ) {
						$displayed_banner = $val;
	        		} else if ( $val['type'] == '2' ) {
						$displayed_popup = $val;
	        		} else if ( $val['type'] == '3' ) {
						$displayed_flyout = $val;
	        		}

        		}
	        }
        }

		// Category

        if (is_category() || is_single()) {

	        foreach ($data as $val) {

		        $args         = $val['args'];
	        	$template     = $val['template'];
        		$trigger      = $val['trigger'];
        		$news_letter  = $val['news_letter'];

        		// Check that conditions are true

        		if (!self::check_conditions($val, $template, $args, $trigger, $displayed_banner, $displayed_flyout, $displayed_popup)) {
	        		continue;
        		}

        		$category_ids = explode(',', $trigger['category']['id']);

        		if ($trigger['display_on'] != 'category') {
	        		continue;
        		}

        		// ID

        		if (isset($trigger['category']['all']) &&
	        		!$trigger['category']['all'] &&
        			(is_category() && in_array($cat, $category_ids)) ||
        			(is_singular() && in_category($category_ids, $post->ID))) {

	        		echo self::generate_code($val, $news_letter);

	        		if ( $val['type'] == '1' ) {
						$displayed_banner = $val;
	        		} else if ( $val['type'] == '2' ) {
						$displayed_popup = $val;
	        		} else if ( $val['type'] == '3' ) {
						$displayed_flyout = $val;
	        		}

        		}
	        }

	        foreach ($data as $val) {

		        $args         = $val['args'];
	        	$template     = $val['template'];
        		$trigger      = $val['trigger'];
        		$news_letter  = $val['news_letter'];

        		// Check that conditions are true

        		if (!self::check_conditions($val, $template, $args, $trigger, $displayed_banner, $displayed_flyout, $displayed_popup)) {
	        		continue;
        		}

        		$category_ids = explode(',', $trigger['category']['id']);

        		if ($trigger['display_on'] != 'category') {
	        		continue;
        		}

        		// All

        		if (isset($trigger['category']['all']) &&
        			$trigger['category']['all'] &&
        			is_category()) {

	        		echo self::generate_code($val, $news_letter);

	        		if ( $val['type'] == '1' ) {
						$displayed_banner = $val;
	        		} else if ( $val['type'] == '2' ) {
						$displayed_popup = $val;
	        		} else if ( $val['type'] == '3' ) {
						$displayed_flyout = $val;
	        		}

        		}
	        }
        }

        // Archive

        if (is_archive()) {
	        foreach ($data as $val) {

		        $args         = $val['args'];
	        	$template     = $val['template'];
        		$trigger      = $val['trigger'];
        		$news_letter  = $val['news_letter'];

        		// Check that conditions are true

        		if (!self::check_conditions($val, $template, $args, $trigger, $displayed_banner, $displayed_flyout, $displayed_popup)) {
	        		continue;
        		}

        		if ($trigger['display_on'] == 'archive') {

	        		echo self::generate_code($val, $news_letter);

	        		if ( $val['type'] == '1' ) {
						$displayed_banner = $val;
	        		} else if ( $val['type'] == '2' ) {
						$displayed_popup = $val;
	        		} else if ( $val['type'] == '3' ) {
						$displayed_flyout = $val;
	        		}

        		}
	        }
        }

        // Front Page

        if (is_front_page()) {
	       foreach ($data as $val) {

		       	$args         = $val['args'];
	        	$template     = $val['template'];
        		$trigger      = $val['trigger'];
        		$news_letter  = $val['news_letter'];

	    		// Check that conditions are true

	    		if (!self::check_conditions($val, $template, $args, $trigger, $displayed_banner, $displayed_flyout, $displayed_popup)) {
	        		continue;
	    		}

	    		if ($trigger['display_on'] == 'frontpage') {

	        		echo self::generate_code($val, $news_letter);

	        		if ( $val['type'] == '1' ) {
						$displayed_banner = $val;
	        		} else if ( $val['type'] == '2' ) {
						$displayed_popup = $val;
	        		} else if ( $val['type'] == '3' ) {
						$displayed_flyout = $val;
	        		}

	    		}
	        }
        }

        // Site

        foreach ($data as $val) {

	        $args         = $val['args'];
        	$template     = $val['template'];
    		$trigger      = $val['trigger'];
    		$news_letter  = $val['news_letter'];

    		// Check that conditions are true

    		if (!self::check_conditions($val, $template, $args, $trigger, $displayed_banner, $displayed_flyout, $displayed_popup)) {
        		continue;
    		}

    		if ($trigger['display_on'] == 'site') {

        		echo self::generate_code($val, $news_letter);

        		if ( $val['type'] == '1' ) {
					$displayed_banner = $val;
        		} else if ( $val['type'] == '2' ) {
					$displayed_popup = $val;
        		} else if ( $val['type'] == '3' ) {
					$displayed_flyout = $val;
        		}
    		}
        }

	}

	/**
	 * Hook function to wp_footer to display optin fire on website
	 *
	 * @since 1.0.0
	 *
	 * @param 	N/A
	 * @return 	N/A
	 */
	static function display_inline($content) {

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/admin/model/db.php');

		global $wpdb;
		global $post;
		global $cat;

		$data = NNRobots_Optin_Fire_DB::get_by_type(array(4));

        // Get all post types that are public

		$post_types = get_post_types(array('public' => true));
		$optin_fire_content = '';

		// Post Types

		if (is_singular()) {

			foreach ($data as $val) {

	        	$args         = $val['args'];
	        	$template     = $val['template'];
        		$trigger      = $val['trigger'];
        		$news_letter  = $val['news_letter'];

        		// Check that conditions are true

        		if (!self::check_conditions($val, $template, $args, $trigger)) {
	        		continue;
        		}

        		$post_ids = array();

        		if (isset($trigger[$post->post_type]['id'])) {
	        		$post_ids = explode(',', $trigger[$post->post_type]['id']);
        		}

	    		// Check if post types match

	    		if (isset($trigger['display_on']) && $trigger['display_on'] != $post->post_type) {
		    		continue;
	    		}

        		// ID

        		if (isset($trigger[$post->post_type]['all']) &&
        			!$trigger[$post->post_type]['all'] &&
	    			in_array($post->ID, $post_ids)) {

	        		// Top of Post

					if (isset($args['placement']['type']) && $args['placement']['type'] == 'before') {
						$content = self::generate_code($val, $news_letter) . $content;
					}

					// Bottom of Post

					else if (isset($args['placement']['type']) && $args['placement']['type'] == 'after') {
						$content .= self::generate_code($val, $news_letter);
					}

					// Paragraphs

					else if (isset($args['placement']['type']) && $args['placement']['type'] == 'paragraphs') {
						$content .= self::generate_code($val, $news_letter);
					}

        		}
	        }

			foreach ($data as $val) {

	        	$args         = $val['args'];
	        	$template     = $val['template'];
        		$trigger      = $val['trigger'];
        		$news_letter  = $val['news_letter'];

        		// Check that conditions are true

        		if (!self::check_conditions($val, $template, $args, $trigger)) {
	        		continue;
        		}

        		$post_ids = array();

        		if (isset($trigger[$post->post_type]['id'])) {
	        		$post_ids = explode(',', $trigger[$post->post_type]['id']);
        		}

	    		// Check if post types match

	    		if (isset($trigger['display_on']) &&
	    			$trigger['display_on'] != $post->post_type &&
	    			$trigger['display_on'] != 'category' &&
	    			$trigger['display_on'] != 'tag') {

					continue;
		    	}

		    	// Tag ID

		    	$tags = explode(',', $trigger['tag']['id']);

        		if ($trigger['display_on'] == 'tag' &&
        			has_tag($tags,$post->ID)) {

	        		// Top of Post

					if (isset($args['placement']['type']) && $args['placement']['type'] == 'before') {
						$content = self::generate_code($val, $news_letter) . $content;
					}

					// Bottom of Post

					else if (isset($args['placement']['type']) && $args['placement']['type'] == 'after') {
						$content .= self::generate_code($val, $news_letter);
					}

					// Paragraphs

					else if (isset($args['placement']['type']) && $args['placement']['type'] == 'paragraphs') {
						$content .= self::generate_code($val, $news_letter);
					}

        		}

        		// Category ID

        		if ($trigger['display_on'] == 'category' &&
        			isset($trigger['category']['all']) &&
        			!$trigger['category']['all'] &&
        			in_category($category_ids, $post->ID)) {

	        		// Top of Post

					if (isset($args['placement']['type']) && $args['placement']['type'] == 'before') {
						$content = self::generate_code($val, $news_letter) . $content;
					}

					// Bottom of Post

					else if (isset($args['placement']['type']) && $args['placement']['type'] == 'after') {
						$content .= self::generate_code($val, $news_letter);
					}

					// Paragraphs

					else if (isset($args['placement']['type']) && $args['placement']['type'] == 'paragraphs') {
						$content .= self::generate_code($val, $news_letter);
					}

        		}

        		// All

        		if ($trigger['display_on'] != 'category' &&
        			$trigger['display_on'] != 'tag' &&
        			isset($trigger[$post->post_type]['all']) &&
        			$trigger[$post->post_type]['all']) {

	        		// Top of Post

					if (isset($args['placement']['type']) && $args['placement']['type'] == 'before') {
						$content = self::generate_code($val, $news_letter) . $content;
					}

					// Bottom of Post

					else if (isset($args['placement']['type']) && $args['placement']['type'] == 'after') {
						$content .= self::generate_code($val, $news_letter);
					}

					// Paragraphs

					else if (isset($args['placement']['type']) && $args['placement']['type'] == 'paragraphs') {
						$content .= self::generate_code($val, $news_letter);
					}

        		}
		    }
		}

        return $content;
	}

	/**
	 * Displays the optin fire
	 *
	 * @since 1.0.0
	 *
	 * @param 	$val the array of the optin fire attr
	 * @param 	$news letter the array of the optin fire attr
	 * @return 	N/A
	 */
	static function generate_code($val, $news_letter, $widget = false) {

		if ( !is_admin() && (!isset($_GET['action']) || (isset($_GET['action']) && $_GET['action'] != 'preview') )) {

			// Check if this optin fire has any A/B Testing

			$args = $val['args'];

			if ( isset($args['ab_testing']['active']) && $args['ab_testing']['active'] &&
				 isset($args['ab_testing']['on']) && $args['ab_testing']['on'] &&
				 isset($args['ab_testing']['is_variant']) && !$args['ab_testing']['is_variant'] &&
				 isset($args['ab_testing']['children']) && is_array($args['ab_testing']['children'])) {

				include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/admin/model/db.php');
				$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();

				// Value of -1 is default and will show the original optin

				if ( !isset($args['ab_testing']['next']) ) {
					$args['ab_testing']['next'] = -1;
				}

				// Show a variant

				if ( $args['ab_testing']['next'] != -1 ) {

					$variant_optin_fire = $nnrobots_optin_fire_db->get_data_from_id($args['ab_testing']['children'][$args['ab_testing']['next']]);

					if ( isset($variant_optin_fire['args']['ab_testing']['on']) && $variant_optin_fire['args']['ab_testing']['on'] ) {
						if ( $args['ab_testing']['next'] >= count($args['ab_testing']['children']) - 1 ) {
							$args['ab_testing']['next'] = -1;
						} else {
							$args['ab_testing']['next']++;
						}

						$val['args'] 		   = $args;
						$nnrobots_optin_fire_db->update_data($val);

						$val 			= $variant_optin_fire;
						$news_letter 	= $variant_optin_fire['news_letter'];
					}
				}

				// Show original

				else {

					$args['ab_testing']['next'] = 0;
					$val['args'] 		   		= $args;
					$nnrobots_optin_fire_db->update_data($val);
				}
			}
		}

		// Include scripts

		self::generate_scripts($val);

		$template                 = $val['template'];
		$trigger                  = $val['trigger'];
		$style                 	  = $val['style'];
		$args                	  = $val['args'];
		$title                    = $val['title'];
		$text                     = $val['text'];
		$image                    = $val['image'];
		$feedburner_id            = $news_letter['feedburner']['id'];
		$news_letter_type         = $news_letter['type'];

		// Create Background Pattern credit to http://www.patternify.com

		$background = '';

		// Backgound Image

		if ( isset($style['background_type']) && $style['background_type'] == 'image' ) {

			$background_image_attributes = wp_get_attachment_image_src($style["background_image"], 'full'); // returns an array

			if( $background_image_attributes ) {
				$background = 'style="background-image: url(' . $background_image_attributes[0] . '); background-size: ' . $style['background_size'] . '; background-repeat: ' . $style['background_repeat'] . '; background-position: ' . $style['background_position'] . ';"';
			}

		} else if ( isset($style['background_type']) && $style['background_type'] == 'pattern' ) {

			// Dots

			if ($style['background_pattern'] == 'dots') {
				$background = 'style="background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAAXNSR0IArs4c6QAAAB1JREFUGBljYGBg4AFiQoAYNYTMGJWHhgAxgckDACfCADFzWBHCAAAAAElFTkSuQmCC);"';
			}

			// Diagonal right

			else if ($style['background_pattern'] == 'diagonal_right') {
				$background = 'style="background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAAXNSR0IArs4c6QAAABVJREFUGBljYCAO8BCjbFQRA/WCAABg/gB584t6RwAAAABJRU5ErkJggg==);"';
			}

			// Diagonal left

			else if ($style['background_pattern'] == 'diagonal_left') {
				$background = 'style="background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAAXNSR0IArs4c6QAAABhJREFUGBljYGBg4AFiosGoYuSgomFoAABg/gB5Q6KWYgAAAABJRU5ErkJggg==);"';
			}

			// Grid

			else if ($style['background_pattern'] == 'grid') {
				$background = 'style="background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAAXNSR0IArs4c6QAAAB1JREFUGBljZGBg4AFiogBRCpmIMgqoaFQh3pACADLgACqd10PPAAAAAElFTkSuQmCC);"';
			}

			// Zig Zag

			else if ($style['background_pattern'] == 'zig_zag') {
				$background = 'style="background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAICAYAAADA+m62AAAAAXNSR0IArs4c6QAAADFJREFUGBljYMAEPJhCmCIwRTAaUwVQBF0SnQ/WhFUQXTMuRTBrCcnD1OG1EUURaRwAYKwAecAGMfQAAAAASUVORK5CYII=);"';
			}

			// Diamonds

			else if ($style['background_pattern'] == 'diamonds') {
				$background = 'style="background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAAXNSR0IArs4c6QAAAEVJREFUGBljYMAEPEAhEMYLkBUgs1E0YZPAEMMQQDICLgdnIEmiM3mY0EUI8fGZiiGHIQA0HZsY2FJkCWQ2VheBFGAoAgCw1ADb2LiCOQAAAABJRU5ErkJggg==);"';
			}

			// Hearts

			else if ($style['background_pattern'] == 'hearts') {
				$background = 'style="background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAAXNSR0IArs4c6QAAADlJREFUGBljYKA14EGzAM5nRJKACyKJwZhfmGAsQjSyiSC12Ez9ApJAV4iuGKwIJIgLYDMZl1oyxQFOKAMqAtJ4RAAAAABJRU5ErkJggg==);"';
			}

			// Circles

			else if ($style['background_pattern'] == 'circles') {
				$background = 'style="background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAAXNSR0IArs4c6QAAADNJREFUGBljYKAH4AFaAsJ4AbICZDaKJmwScDEmFKUkcOAmAPUgs7EaAVJAUBFWnSQJAgBkhAB7H4o0xwAAAABJRU5ErkJggg==);"';
			}

			// X Out

			else if ($style['background_pattern'] == 'x_out') {
				$background = 'style="background-image: url(data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAYAAACNMs+9AAAAAXNSR0IArs4c6QAAADRJREFUGBljYKAl4MFiODYxsDJkCWQ2FjMYGEAKMBQxYVVKhCCySchsFK3YJLCJoWginwMAZIQAe7Ze2SMAAAAASUVORK5CYII=);"';
			}
		}

		$optin_fire_content = '';

		include(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/templates/optin-fire.php');

		return $optin_fire_content;
	}

	/**
	 * Adds the scripts and localizes the variables
	 *
	 * @since 1.0.0
	 *
	 * @param 	$val array of attrs
	 * @return 	N/A
	 */
	static function generate_scripts($val) {

		$newsletter	= $val['news_letter'];
		$template 	= $val['template'];
		$style    	= $val['style'];
		$args    	= $val['args'];

		if ($val['type'] != '1' && $val['type'] != '3') {
			wp_enqueue_style(
				NNRobots_Optin_Fire::$prefix . 'template_' . $template['type'] . '_css',
				NNROBOTS_OPTIN_FIRE_PLUGIN_URL . '/templates/template-' . $template['type'] . '/template-' . $template['type'] . '.css'
			);
		}

		wp_enqueue_style(
			NNRobots_Optin_Fire::$prefix . 'css-' . $val['type'] . '',
			NNROBOTS_OPTIN_FIRE_PLUGIN_URL . '/templates/optin-fire-' . $val['type'] . '.css'
		);

		wp_enqueue_style(
			NNRobots_Optin_Fire::$prefix . 'fontawesome_css',
			NNROBOTS_OPTIN_FIRE_PLUGIN_URL . '/admin/fonts/font-awesome.min.css'
		);

		// Google Font Loader

		if ((isset($style['heading_google_fonts']) && $style['heading_google_fonts']) ||
			(isset($style['google_fonts']) && $style['google_fonts'])) {

			wp_enqueue_script(
				NNRobots_Optin_Fire::$prefix . 'google_font_js',
				NNROBOTS_OPTIN_FIRE_PLUGIN_URL .  '/core/js/webfontloader.js'
			);

		}

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . '/admin/functions.php');

		$default_optin_fire = NNRobots_Optin_Fire_Admin_Functions::default_optin_fire();

	    $args_array = array(
			'prefix_dash'            => NNRobots_Optin_Fire::$prefix_dash,
			'preview'                => isset($_GET['action']) && $_GET['action'] == 'preview' ? true : false,
			'edit'                	 => $_GET['page'] == NNRobots_Optin_Fire::$add_new_page ? true : false,
			'ajaxurl'                => admin_url( 'admin-ajax.php' ),
		);

		if (is_admin() && isset($_GET['action']) && ( $_GET['action'] == 'preview' || $_GET['action'] == 'edit') ) {

			wp_enqueue_script(
				NNRobots_Optin_Fire::$prefix . 'preview_js',
				NNROBOTS_OPTIN_FIRE_PLUGIN_URL . '/core/js/optin-fire.js', array('jquery', 'jquery-ui-core', 'jquery-effects-' . $template['args']['effect'])
			);

			wp_localize_script(NNRobots_Optin_Fire::$prefix . 'preview_js', 'nnr_of_data', $args_array);

		} else {

			wp_enqueue_script(
				NNRobots_Optin_Fire::$prefix . 'js',
				NNROBOTS_OPTIN_FIRE_PLUGIN_URL . '/core/js/optin-fire.js', array('jquery', 'jquery-ui-core', 'jquery-effects-' . $template['args']['effect'])
			);

			wp_localize_script(NNRobots_Optin_Fire::$prefix . 'js', 'nnr_of_data', $args_array);
		}
	}

	/**
	 * AJAX funciton used to get all styling data for the optin fire.
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_styling_data() {

		// Check if optin fire id is set

		if (!isset($_POST['optin_fire_id']) || empty($_POST['optin_fire_id'])) {
			echo '';
			die();
		}

		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . "/admin/model/db.php");
		include_once(NNROBOTS_OPTIN_FIRE_PLUGIN_DIR . "/admin/functions.php");

		global $wpdb;

		// Get all Optins

		$nnrobots_optin_fire_db = new NNRobots_Optin_Fire_DB();
		$optin = $nnrobots_optin_fire_db->get_data_from_id($_POST['optin_fire_id']);

		$style 		= $optin['style'];
		$template 	= $optin['template'];

		$default_optin_fire = NNRobots_Optin_Fire_Admin_Functions::default_optin_fire();

		echo json_encode(array(
			'id'                        => $_POST['optin_fire_id'],
			'heading_color'             => isset($style['heading_color']) ? $style['heading_color'] : $default_optin_fire['style']['heading_color'],
			'color'                		=> isset($style['color']) ? $style['color'] : $default_optin_fire['style']['color'],
			'background_color'          => isset($style['background_color']) ? $style['background_color'] : $default_optin_fire['style']['background_color'],
			'border_color'              => isset($style['border_color']) ? $style['border_color'] : $default_optin_fire['style']['border_color'],
			'nl_color'                  => isset($style['nl_color']) ? $style['nl_color'] : $default_optin_fire['style']['nl_color'],
			'nl_bg_color'               => isset($style['nl_bg_color']) ? $style['nl_bg_color'] : $default_optin_fire['style']['nl_bg_color'],
			'cu_color'                  => isset($style['cu_color']) ? $style['cu_color'] : $default_optin_fire['style']['cu_color'],
			'cu_bg_color'               => isset($style['cu_bg_color']) ? $style['cu_bg_color'] : $default_optin_fire['style']['cu_bg_color'],
			'yes_color'                 => isset($style['yes_color']) ? $style['yes_color'] : $default_optin_fire['style']['yes_color'],
			'yes_bg_color'              => isset($style['yes_bg_color']) ? $style['yes_bg_color'] : $default_optin_fire['style']['yes_bg_color'],
			'no_color'                  => isset($style['no_color']) ? $style['no_color'] : $default_optin_fire['style']['no_color'],
			'no_bg_color'               => isset($style['no_bg_color']) ? $style['no_bg_color'] : $default_optin_fire['style']['no_bg_color'],
			'font_size'                 => isset($style['font_size']) ? $style['font_size'] : $default_optin_fire['style']['font_size'],
	    	'font_weight'             	=> isset($style['font_weight']) ? $style['font_weight'] : $default_optin_fire['style']['font_weight'],
	    	'google_fonts'            	=> isset($style['google_fonts']) ? $style['google_fonts'] : $default_optin_fire['style']['google_fonts'],
	    	'heading_google_fonts'    	=> isset($style['heading_google_fonts']) ? $style['heading_google_fonts'] : $default_optin_fire['style']['heading_google_fonts'],
	    	'font_family_heading'     	=> isset($style['font_family_heading']) ? $style['font_family_heading'] : $default_optin_fire['style']['font_family_heading'],
	    	'font_family'             	=> isset($style['font_family']) ? $style['font_family'] : $default_optin_fire['style']['font_family'],
	    	'text_align'              	=> isset($style['text_align']) ? esc_attr($style['text_align']) : $default_optin_fire['style']['text_align'],
	    	'icon_color'              	=> isset($style['icon_color']) ? esc_attr($style['icon_color']) : $default_optin_fire['style']['icon_color'],
	    	'close_button_color'        => isset($style['close_button_color']) ? esc_attr($style['close_button_color']) : $default_optin_fire['style']['close_button_color'],
	    	'list_color'            	=> isset($template['args']['list']['color']) ? esc_attr($template['args']['list']['color']) : $default_optin_fire['template']['args']['list']['color'],
	    	'social_color'            	=> isset($template['args']['social']['color']) ? esc_attr($template['args']['social']['color']) : $default_optin_fire['template']['args']['social']['color'],
	    	'border_size'             	=> isset($style['border_size']) ? esc_attr($style['border_size']) : $default_optin_fire['style']['border_size'],
	    	'position'                	=> isset($template['args']['position']) ? esc_attr($template['args']['position']) : $default_optin_fire['template']['args']['position'],
		));

		die();
	}

	/**
	 * Checks that all optin fire conditions are met
	 *
	 * @access public
	 * @static
	 * @param mixed $val
	 * @param mixed $template
	 * @param mixed $args
	 * @param mixed $trigger
	 * @param mixed $displayed_banner
	 * @param mixed $displayed_flyout
	 * @param mixed $displayed_popup
	 * @return void
	 */
	static function check_conditions($val, $template, $args, $trigger, $displayed_banner = null, $displayed_flyout = null, $displayed_popup = null) {

		global $post;

		// Check if user closed popup and dont not show is set to true

		if ( isset($args['show_after_success']) && $args['dont_show_again'] == 'yes' && isset($_COOKIE[NNRobots_Optin_Fire::$prefix . 'close_' . $val['id']])) {
			return false;
		}

		// Check if user has already signed up

		if ( isset($args['show_after_success']) && $args['show_after_success'] == 'no' &&
			in_array($template['type'], NNRobots_Optin_Fire::$newsletter_templates) &&
			isset($_COOKIE[NNRobots_Optin_Fire::$prefix . 'email_success_' . $val['id']])) {
			return false;
		}

		// Check if optin should only display manually

		if ( isset($trigger['manual_display']) && $trigger['manual_display'] == 'yes') {
			return false;
		}

		// Check if mobile

    	if ( isset($args['display_screen']) && ($args['display_screen'] == 'device' && !wp_is_mobile()) || ($args['display_screen'] == 'computer' && wp_is_mobile())) {
    		return false;
		}

		// Check user role

		if (!self::check_user_role($trigger['args'])) {
    		return false;
		}

		// Check referrer

		if (!self::check_referrer($trigger['args'])) {
			return false;
		}

		// Check for excluded posts

		if ( is_singular() &&
			 isset($trigger[$post->post_type]['exclude']) &&
			 in_array($post->ID, explode(',', $trigger[$post->post_type]['exclude'])) ) {

    		return false;
		}

		// Date Range

		$now = time();

		if (isset($args['start_date']) && isset($args['end_date']) &&
			(strtotime($args['start_date']) > $now || strtotime($args['end_date']) < $now)) {
    		return false;
		}

		// Check if this is a variant

		if ( isset($args['ab_testing']['is_variant']) && $args['ab_testing']['is_variant'] ) {
			return false;
		}

		// Check if banner is already display in same location

		if ( isset( $displayed_banner ) && $val['type'] == '1') {

			if ( $displayed_banner['template']['args']['banner_location'] == $template['args']['banner_location']) {
				return false;
			}
		}

		// Check if flyout is already display in same location

		if ( isset( $displayed_flyout ) && $val['type'] == '3' ) {

			if ( $displayed_flyout['template']['args']['location'] == $template['args']['location']) {
				return false;
			}
		}

		return true;
	}

	/**
	 * Determines if the referrer URL matches any given by the user
	 *
	 * @access public
	 * @static
	 * @param mixed $settings
	 * @return void
	 */
	static function check_referrer($settings) {

		// Return true any domain is checked

		if ($settings['referrer_type'] == 'any') {
			return true;
		}

		// Check is referrer domain matches ones given by user

		else if (isset($_SERVER["HTTP_REFERER"])) {

			$urls = explode(',', $settings['referrer']);
			$domain = parse_url($_SERVER["HTTP_REFERER"]);

			if (in_array($domain['host'], $urls)) {
				return true;
			}
		}

		return false;
	}

	/**
     * Check if the current user has access to backend / frontend based on his role compared with role from settings
     *
     * @access public
     * @static
     * @param mixed $settings
     * @return void
     */
    static function check_user_role($settings) {

		// Check if Everyone users is true

		if (isset($settings['users']) && $settings['users'] == 'everyone') {
			return true;
		}

		// Check if All users is true

		else if (isset($settings['users']) && $settings['users'] == 'logged_in' && is_user_logged_in()) {
			return true;
		}

		// Check if Logged Out Users is true

		else if (isset($settings['users']) && $settings['users'] == 'logged_out' && !is_user_logged_in()) {
			return true;
		}

		// Check if Specific User is true

		else if (isset($settings['users']) && $settings['users'] == 'specific' && is_user_logged_in()) {

			$is_allowed = false;
			global $wp_roles;
			$current_user = wp_get_current_user();

			foreach ($wp_roles->role_names as $role_name => $role) {

				if (isset($settings['user_roles'][$role_name]) && $settings['user_roles'][$role_name] && in_array($role_name, $current_user->roles)) {
					$is_allowed = true;
				}
			}

			return $is_allowed;
		}

        return false;
    }

    /**
	 * Gets all the class names for the Banner
	 *
	 * @access public
	 * @static
	 * @return void
	 */
	static function get_classes($args = null, $template = null, $location = null, $stub_location = null){

		// Return nothing if we did not get our data

		if ( !isset($args) || !isset($template) || !isset($location) || !isset($stub_location)) {
			return null;
		}

		$shadow       = isset($args['shadow']) && $args['shadow'] == 'yes' ?
						NNRobots_Optin_Fire::$prefix_dash . 'container-' . strtolower($location) . '-shadow' :
						'';

		$container    = NNRobots_Optin_Fire::$prefix_dash . 'container ' .
						NNRobots_Optin_Fire::$prefix_dash . 'container-' . strtolower($location) . ' ' . $shadow . ' ' .
						NNRobots_Optin_Fire::$prefix_dash . 'container-' . $template['type'];

		$stub         = NNRobots_Optin_Fire::$prefix_dash . 'stub ' .
						NNRobots_Optin_Fire::$prefix_dash . 'stub-' . strtolower($location) . ' ' .
						NNRobots_Optin_Fire::$prefix_dash . 'stub-' . $stub_location;

		if ( !$args['close_button'] ) {
			$close    = NNRobots_Optin_Fire::$prefix_dash . 'close ' .
					    NNRobots_Optin_Fire::$prefix_dash . 'close-' . $stub_location . ' fa ' . $template['args']['icon'];
		} else {
			$close    = NNRobots_Optin_Fire::$prefix_dash . 'close ' .
						NNRobots_Optin_Fire::$prefix_dash . 'close-button ' .
					    NNRobots_Optin_Fire::$prefix_dash . 'close-' . $stub_location . ' fa fa fa-times';
		}

		return array(
			'container'	=> $container,
			'stub'		=> $stub,
			'close'		=> $close,
		);
	}

	/**
     * Sets the close cookie so that the optin does not show after user closes it out
     *
     * @access public
     * @static
     * @return void
     */
    static function set_close_cookie() {

	    if (!isset($_POST['optin_fire_id'])) {
		    echo 'Optin ID was not found so cookie could not be set.';
		    die();
	    }

	    setcookie(NNRobots_Optin_Fire::$prefix . 'close_' . $_POST['optin_fire_id'], true, 0, '/');

		echo 'Cookie was set';
		die();
    }

    /**
     * Outputs HTML properly
     *
     * @access public
     * @static
     * @param mixed $html
     * @return void
     */
    static function output_html_shortcode($html){
	    return do_shortcode( stripcslashes( html_entity_decode( $html ) ) );
    }
}

//endif;