/**
 *
 * Created by Kyle Benk
 *
 */

/**
 * Add the proper styling to the Popup
 *
 * @access public
 * @return void
 */
function addStyling(wrap, show, optin) {

	wrap.data('show', show);

	if ( !nnr_of_data.preview && !nnr_of_data.edit && show && wrap.hasClass(nnr_of_data.prefix_dash + 'styled') ) {

		//console.log('Show Optin: ' + wrap.data('id'));

     	if (wrap.data('trigger') == 'exit' || wrap.data('trigger') == 'scroll') {
			if (!wrap.hasClass(nnr_of_data.prefix_dash + 'shown')) {

				// Banner

				if (wrap.data('type') == '1') {
					nnrobots_banner_show(wrap);
			    }

				// Popup

				else if (wrap.data('type') == '2') {
					wrap.bPopup({
			            modalClose: true,
			            opacity: 0.8,
			            positionStyle: 'fixed', //'fixed' or 'absolute'
			            speed: 650,
						transition: wrap.data('popup-animation'),
			        });
			        jQuery(window).resize();
				}

				// Flyout

				else if (wrap.data('type') == '3') {
					nnrobots_flyout_show(wrap);
				}

				wrap.addClass(nnr_of_data.prefix_dash + 'shown');
			}
		}

		else {

			// Banner

			if (wrap.data('type') == '1') {
				nnrobots_banner_show(wrap);
		    }

			// Popup

			else if (wrap.data('type') == '2') {
				wrap.bPopup({
		            modalClose: true,
		            opacity: 0.8,
		            positionStyle: 'fixed', //'fixed' or 'absolute'
					speed: 400,
					transition: wrap.data('popup-animation'),
		        });
		        jQuery(window).resize();
			}

			// Flyout

			else if (wrap.data('type') == '3') {
				nnrobots_flyout_show(wrap);
			}

			// Shortcode or Widget

			else {
				wrap.fadeIn();
			}

			wrap.addClass(nnr_of_data.prefix_dash + 'shown');
		}

        onVisibilityChange(wrap);
    }

	if ( nnr_of_data.edit ) {
		wrap.css('margin', '0 auto');

		if (wrap.data('type') == '5') {
		    wrap.css('max-width', '250px');
		    wrap.css('margin', '0 auto');
	    } else if ( wrap.data('type') == '2' || wrap.data('type') == '3' || wrap.data('type') == '4' ) {
		   	wrap.css('max-width', '700px');
		   	wrap.css('display', 'block');
		   	wrap.css('position', 'relative');
		   	wrap.css('z-index', '9');
	    } else if (wrap.data('type') == '1') {
		    wrap.css('display', 'block');
	    }

	    if (wrap.data('type') == '3') {
		    wrap.find('.' + nnr_of_data.prefix_dash + 'container').css('position', 'relative');
		}
	}

	if ( show && wrap.hasClass(nnr_of_data.prefix_dash + 'styled') ) {
		//console.log('Trying to show Optin: ' + wrap.data('id'));
		return;
	}

	// Check if we are already styling this optin

	if ( wrap.hasClass(nnr_of_data.prefix_dash + 'styling') || wrap.hasClass(nnr_of_data.prefix_dash + 'styled') ) {
		return;
	} else {
		wrap.addClass(nnr_of_data.prefix_dash + 'styling')
	}

	//console.log('Trying to add styling to Optin: ' + wrap.data('id'));

	// Get relavtive data

	var data = {
		'action': 'nnr_of_get_styling_data',
		'optin_fire_id': wrap.data('id')
	};

	// Get all the style data and style this optin correctly

	jQuery.post(nnr_of_data.ajaxurl, data, function(response) {

		if ( optin ) {
			var styling = optin.style;
			styling.list_color = optin.template.args.list.color;
			styling.social_color = optin.template.args.social.color;
			styling.position = optin.template.args.position;
			var wrap = jQuery('.' + nnr_of_data.prefix_dash + 'wrap');
		} else {
			var styling = jQuery.parseJSON(response);
			var wrap = jQuery('.' + nnr_of_data.prefix_dash + 'wrap-' + styling.id);
		}

		var border_location = 'top';

		if (wrap.data('banner-location') == 'top') {
			border_location = 'bottom';
		}

		// Move the Flyout Fire if user resizes window

		if ( !nnr_of_data.preview && !nnr_of_data.edit && wrap.data('type') == '3' &&
			wrap.data('full') != 'yes' && (wrap.data('flyout-location') == '4' || wrap.data('flyout-location') == '6') ) {

			jQuery(window).resize(function(){

			    wrap.find('.' + nnr_of_data.prefix_dash + 'container').css({
			        position:'fixed',
			        top: (jQuery(window).height() - wrap.find('.' + nnr_of_data.prefix_dash + 'container').outerHeight())/2
			    });

			    wrap.find('.' + nnr_of_data.prefix_dash + 'stub').css({
			        position:'fixed',
			        top: (jQuery(window).height() - wrap.find('.' + nnr_of_data.prefix_dash + 'stub').outerHeight())/2
			    });

			});

			jQuery(window).resize();
		}

		// Add Google Fonts

		if (styling.heading_google_fonts) {
			nnr_of_addGoogleFont(styling.font_family_heading);
		}

		if (styling.google_fonts) {
			nnr_of_addGoogleFont(styling.font_family);
		}

		// Font Color and Family for Custom HTML template

		wrap.find('.' + nnr_of_data.prefix_dash + 'container').css('background-color', styling.background_color);
		wrap.find('.' + nnr_of_data.prefix_dash + 'show').css('background-color', styling.background_color);
		wrap.find('.' + nnr_of_data.prefix_dash + 'container').find('*')
			.not('i')
			.not('.' + nnr_of_data.prefix_dash + 'icon')
			.not('.' + nnr_of_data.prefix_dash + 'title')
			.not('.' + nnr_of_data.prefix_dash + 'close')
			.css('font-family', styling.font_family);

		wrap.find('.' + nnr_of_data.prefix_dash + 'title').css('font-family', styling.font_family_heading);
		wrap.find('.' + nnr_of_data.prefix_dash + 'title *').css('font-family', styling.font_family_heading);
		wrap.find('.' + nnr_of_data.prefix_dash + 'text').css('font-family', styling.font_family);
		wrap.find('.' + nnr_of_data.prefix_dash + 'text *').css('font-family', styling.font_family);

        wrap.find('.' + nnr_of_data.prefix_dash + 'container').find('p')
        	.css('font-size', parseInt(styling.font_size) + 'px');
		wrap.find('.' + nnr_of_data.prefix_dash + 'container').find('p').css('font-weight', styling.font_weight);

		// Small

		if ( parseInt(styling.font_size) == 14 ) {
			wrap.find('.' + nnr_of_data.prefix_dash + 'link-button').css('padding', '1px 5px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'form input, .' + nnr_of_data.prefix_dash + 'form button, .' + nnr_of_data.prefix_dash + 'form textarea').css('padding', '1px 5px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'form input, .' + nnr_of_data.prefix_dash + 'form button, .' + nnr_of_data.prefix_dash + 'form textarea').css('height', '28px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'icon').css('font-size', parseInt(styling.font_size) + 2 + 'px');
		}

		// Medium

		else if ( parseInt(styling.font_size) == 18) {
			wrap.find('.' + nnr_of_data.prefix_dash + 'link-button').css('padding', '5px 10px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'form input, .' + nnr_of_data.prefix_dash + 'form button, .' + nnr_of_data.prefix_dash + 'form textarea').css('padding', '5px 10px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'form input, .' + nnr_of_data.prefix_dash + 'form button, .' + nnr_of_data.prefix_dash + 'form textarea').css('height', '30px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'icon').css('font-size', parseInt(styling.font_size) + 3 + 'px');
		}

		// Large

		else if ( parseInt(styling.font_size) == 24) {
			wrap.find('.' + nnr_of_data.prefix_dash + 'link-button').css('padding', '6px 12px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'form input, .' + nnr_of_data.prefix_dash + 'form button, .' + nnr_of_data.prefix_dash + 'form textarea').css('padding', '6px 12px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'form input, .' + nnr_of_data.prefix_dash + 'form button, .' + nnr_of_data.prefix_dash + 'form textarea').css('height', '32px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'icon').css('font-size', parseInt(styling.font_size) + 4 + 'px');
		}

		// Auto

		else {
			wrap.find('.' + nnr_of_data.prefix_dash + 'link-button').css('padding', '5px 10px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'form input, .' + nnr_of_data.prefix_dash + 'form button, .' + nnr_of_data.prefix_dash + 'form textarea').css('padding', '5px 10px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'form input, .' + nnr_of_data.prefix_dash + 'form button, .' + nnr_of_data.prefix_dash + 'form textarea').css('height', '30px');
			wrap.find('.' + nnr_of_data.prefix_dash + 'icon').css('font-size', '22px');
		}

		wrap.find('.' + nnr_of_data.prefix_dash + 'image .' + nnr_of_data.prefix_dash + 'link-button').css('padding', '0');

		// Banner Styling

		if (!nnr_of_data.preview && !nnr_of_data.edit && wrap.data('type') == '1') {
			if (wrap.data('banner-location') == 'bottom' && wrap.data('position') == 'absolute' &&
				wrap.find('.' + nnr_of_data.prefix_dash + 'container').css('top') == 'auto') {
				var offset= jQuery(document).height();
				wrap.find('.' + nnr_of_data.prefix_dash + 'container').css('top', offset);
				wrap.find('.' + nnr_of_data.prefix_dash + 'stub').css('top', offset);
			}

			wrap.find('.' + nnr_of_data.prefix_dash + 'container').css('position', styling.position);
			wrap.find('.' + nnr_of_data.prefix_dash + 'stub').css('position', styling.position);
		}

		if ( wrap.data('type') == '1' ) {

			wrap.find('.' + nnr_of_data.prefix_dash + 'container').css('border-' + border_location, styling.border_size + 'px solid ' + styling.border_color);
			wrap.find('.' + nnr_of_data.prefix_dash + 'close-button').css('color', styling.close_button_color);
		}

		// Popup Styling

		else if (wrap.data('type') == '2') {

			wrap.find('.' + nnr_of_data.prefix_dash + 'container').css('border-color', styling.border_color);
			wrap.find('.' + nnr_of_data.prefix_dash + 'container').css('border', styling.border_size + 'px solid ' + styling.border_color);
			wrap.find('.' + nnr_of_data.prefix_dash + 'form textarea').css('height', '80px');
		}

		// Flyout Styling

		else if (wrap.data('type') == '3') {
			nnrobots_border_style(wrap);
			wrap.find('.' + nnr_of_data.prefix_dash + 'close-button .fa-times').css('color', styling.close_button_color);

			//wrap.find('.' + nnr_of_data.prefix_dash + 'container').css('text-align', styling.text_align);
			wrap.find('.' + nnr_of_data.prefix_dash + 'title').css('text-align', styling.text_align);
			wrap.find('.' + nnr_of_data.prefix_dash + 'heading').css('text-align', styling.text_align);
			wrap.find('.' + nnr_of_data.prefix_dash + 'text').css('text-align', styling.text_align);
		}

		else if (wrap.data('type') == '4' || wrap.data('type') == '5') {
			wrap.find('.' + nnr_of_data.prefix_dash + 'form textarea').css('height', '80px');
		}

		// Color Style

		wrap.find('.' + nnr_of_data.prefix_dash + 'show').css('color', styling.icon_color);
		wrap.find('.' + nnr_of_data.prefix_dash + 'show').css('border', styling.border_size + 'px solid ' + styling.border_color);
		wrap.find('.' + nnr_of_data.prefix_dash + 'close')
			.not('.' + nnr_of_data.prefix_dash + 'close-button')
			.css('color', styling.icon_color);

		// Color

		wrap.find('.' + nnr_of_data.prefix_dash + 'title').css('color', styling.heading_color);
		wrap.find('.' + nnr_of_data.prefix_dash + 'text').css('color', styling.color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'list').css('color', styling.color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'footer').css('color', styling.color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'message').css('color', styling.color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'icon').css('color', styling.social_color);

        wrap.find('.' + nnr_of_data.prefix_dash + 'container div').css('color', styling.color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'container p').css('color', styling.color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'container span')
        	.not('.' + nnr_of_data.prefix_dash + 'close-button')
        	.css('color', styling.color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'container a')
        	.not('.' + nnr_of_data.prefix_dash + 'icon')
        	.not('.' + nnr_of_data.prefix_dash + 'link-button')
        	.css('color', styling.color);

        // News letter submit button

        wrap.find('.' + nnr_of_data.prefix_dash + 'newsletter button[type="submit"]').css('color', styling.nl_color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'newsletter button[type="submit"]').css('background-color', styling.nl_bg_color);

        // Contact Form submit button

        wrap.find('.' + nnr_of_data.prefix_dash + 'contact-us button[type="submit"]').css('color', styling.cu_color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'contact-us button[type="submit"]').css('background-color', styling.cu_bg_color);

        // Yes / No buttons

        wrap.find('.' + nnr_of_data.prefix_dash + 'yes *').css('color', styling.yes_color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'yes').css('background-color', styling.yes_bg_color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'no *').css('color', styling.no_color);
        wrap.find('.' + nnr_of_data.prefix_dash + 'no').css('background-color', styling.no_bg_color);

        wrap.addClass(nnr_of_data.prefix_dash + 'styled');

        addStyling(wrap, wrap.data('show'), false);

        //console.log('Added style to Optin: ' + wrap.data('id'));
	});
}

/**
 * Check if optin form has been seen
 *
 * @access public
 * @param mixed el
 * @return void
 */
function onVisibilityChange (el) {

    if (!jQuery('.' + nnr_of_data.prefix_dash + 'wrap-' + el.attr('data-id')).hasClass(nnr_of_data.prefix_dash + 'seen') &&
    	jQuery('.' + nnr_of_data.prefix_dash + 'wrap-' + el.attr('data-id')).hasClass(nnr_of_data.prefix_dash + 'styled') &&
    	jQuery('.' + nnr_of_data.prefix_dash + 'wrap-' + el.attr('data-id')).hasClass(nnr_of_data.prefix_dash + 'shown') &&
    	nnr_isElementInViewport(el)) {

		var data = {
			'action': 'nnr_of_record_impression',
			'optin_fire_id': el.attr('data-id')
		};
		// We can also pass the url value separately from ajaxurl for front end AJAX implementations
		jQuery.post(nnr_of_data.ajaxurl, data, function(response) {
			console.log(response);
		});

		//console.log('seen');

		jQuery('.' + nnr_of_data.prefix_dash + 'wrap-' + el.attr('data-id')).addClass(nnr_of_data.prefix_dash + 'seen');
    }
}

/**
 * Determines if the Optin is in the viewport of not
 *
 * @access public
 * @param mixed el
 * @return void
 */
function nnr_isElementInViewport(el) {

	if ( nnr_of_data.preview || nnr_of_data.edit ) {
		return false;
	}

	if (el.length == 0 &&
		el.find('.' + nnr_of_data.prefix_dash + 'container').css('display') == 'none') {
		return false;
	}

	if (typeof el.find('.' + nnr_of_data.prefix_dash + 'container').position().top !== 'undefined') {
		return ( el.find('.' + nnr_of_data.prefix_dash + 'container').position().top >= 0 &&
				 el.find('.' + nnr_of_data.prefix_dash + 'container').position().left >= 0 &&
				 el.find('.' + nnr_of_data.prefix_dash + 'container').position().top <= (jQuery(window).scrollTop() + jQuery(window).height()));
	}

    return false;
}

/**
 * Adds a google font
 *
 * @access public
 * @return void
 */
function nnr_of_addGoogleFont(font) {

	WebFont.load({
		google: {
		  families: [font]
		}
	});

}

/**
 * Show firebar
 *
 * @access public
 * @param mixed location
 * @return void
 */
function nnrobots_banner_show(wrap) {

	var container = '.' + nnr_of_data.prefix_dash + 'container-' + wrap.data('banner-location');
	var stub = '.' + nnr_of_data.prefix_dash + 'stub-' + wrap.data('banner-location');

	if (wrap.data('banner-animation') == 'yes') {

		wrap.find(stub).slideUp('normal', function() {
	      	wrap.find(container).show({effect: wrap.data('effect')}, 500);
	  	});

	} else {
		wrap.find(container).show();
		wrap.find(stub).hide();
	}

	jQuery(window).load(function() {

		if (wrap.data('banner-animation') == 'yes') {

			wrap.find(stub).slideUp('normal', function() {
		      	wrap.find(container).show({effect: wrap.data('effect')}, 500);
		  	});

		} else {
			wrap.find(container).show();
			wrap.find(stub).hide();
		}

		// Move Body

		if (wrap.data('move-body') == 'yes') {
			if (wrap.data('banner-location') == 'top') {
				jQuery('body').animate({paddingTop: wrap.find('.' + nnr_of_data.prefix_dash + 'container').outerHeight()}, 300);
			} else {
				jQuery('body').animate({paddingBottom: wrap.find('.' + nnr_of_data.prefix_dash + 'container').outerHeight()}, 300);
			}
      	}
	});

	// Move Body

	if (wrap.data('move-body') == 'yes') {
		if (wrap.data('banner-location') == 'top') {
			jQuery('body').animate({paddingTop: wrap.find('.' + nnr_of_data.prefix_dash + 'container').outerHeight()}, 300);
		} else {
			jQuery('body').animate({paddingBottom: wrap.find('.' + nnr_of_data.prefix_dash + 'container').outerHeight()}, 300);
		}
  	}

  	onVisibilityChange(wrap);
}

/**
 * Show firebar based on location and what slide direction
 *
 * @access public
 * @param mixed location
 * @return void
 */
function nnrobots_flyout_show(wrap) {

	wrap.find('.' + nnr_of_data.prefix_dash + 'container').show();

	var width = wrap.find('.' + nnr_of_data.prefix_dash + 'stub').outerWidth();
	var height = wrap.find('.' + nnr_of_data.prefix_dash + 'stub').outerHeight();

	var stub_animation, container_animation;

	switch (wrap.data('flyout-location')) {

		case 1:

			if (wrap.data('slide-direction') == 'up') {
				stub_animation  = {top: '-=' + height + 'px'};
				container_animation = {top: '0px'};
			} else {
				stub_animation  = {left: '-=' + width + 'px'};
				container_animation = {left: '0px'};
			}

			break;

		case 2:

			stub_animation  = {top: '-=' + height + 'px'};
			container_animation = {top: '0px'};

			break;

		case 3:

			if (wrap.data('slide-direction') == 'up') {
				stub_animation  = {top: '-=' + height + 'px'};
				container_animation = {top: '0px'};
			} else {
				stub_animation  = {right: '-=' + width + 'px'};
				container_animation = {right: '0px'};
			}

			break;

		case 4:

			stub_animation  = {left: '-=' + width + 'px'};
			container_animation = {left: '0px'};

			break;

		case 6:

			stub_animation  = {right: '-=' + width + 'px'};
			container_animation = {right: '0px'};

			break;

		case 7:

			if (wrap.data('slide-direction') == 'down') {
				stub_animation  = {bottom: '-=' + height + 'px'};
				container_animation = {bottom: '0px'};
			} else {
				stub_animation  = {left: '-=' + width + 'px'};
				container_animation = {left: '0px'};
			}

			break;

		case 8:

			stub_animation  = {bottom: '-=' + height + 'px'};
			container_animation = {bottom: '0px'};

			break;

		case 9:

			if (wrap.data('slide-direction') == 'down') {
				stub_animation  = {bottom: '-=' + height + 'px'};
				container_animation = {bottom: '0px'};
			} else {
				stub_animation  = {right: '-=' + width + 'px'};
				container_animation = {right: '0px'};
			}

			break;
	}

		if (wrap.data('full') == 'yes' && wrap.data('push-pull') == 'yes') {

  		jQuery('body').css('position', 'relative');

		if (wrap.data('flyout-location') == '1' || wrap.data('flyout-location') == '2' || wrap.data('flyout-location') == '3') {
			jQuery('body').animate({top: '+=' + (jQuery('.' + nnr_of_data.prefix_dash + 'container').outerHeight() + 20) + 'px'});
		} else if (wrap.data('flyout-location') == '4') {
			jQuery('body').animate({left: '+=' + (jQuery('.' + nnr_of_data.prefix_dash + 'container').outerWidth() + 20) + 'px'});
		} else if (wrap.data('flyout-location') == '6') {
			jQuery('body').animate({right: '+=' + (jQuery('.' + nnr_of_data.prefix_dash + 'container').outerWidth() + 20) + 'px'});
		} else if (wrap.data('flyout-location') == '7' || wrap.data('flyout-location') == '8' || wrap.data('flyout-location') == '9') {
			jQuery('body').animate({bottom: '+=' + (jQuery('.' + nnr_of_data.prefix_dash + 'container').outerHeight() + 20) + 'px'});
		}
	}

	wrap.find('.' + nnr_of_data.prefix_dash + 'stub').animate(stub_animation, 500, function() {
		wrap.find('.' + nnr_of_data.prefix_dash + 'container').animate(container_animation);
		onVisibilityChange(wrap);
	});
}

/**
 * Adds the right border style to the container
 *
 * @access public
 * @param mixed location
 * @return void
 */
function nnrobots_border_style(wrap){

	var container = wrap.find('.' + nnr_of_data.prefix_dash + 'container');

	switch (wrap.data('flyout-location')) {

		case 1:
			container.css('border-bottom', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-right', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			break;

		case 2:
			container.css('border-bottom', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-right', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-left', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			break;

		case 3:
			container.css('border-bottom', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-left', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			break;

		case 4:
			container.css('border-bottom', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-right', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-top', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			break;

		case 5:
			container.css('border', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			break;

		case 6:
			container.css('border-bottom', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-left', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-top', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			break;

		case 7:
			container.css('border-top', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-right', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			break;

		case 8:
			container.css('border-top', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-left', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-right', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			break;

		case 9:
			container.css('border-top', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			container.css('border-left', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			break;

		default:
			container.css('border', wrap.data('border-size') + 'px solid ' + wrap.data('border-color'));
			break;
	}
}

jQuery(document).ready(function($) {

	if (typeof(nnr_of_data) != "undefined" && nnr_of_data !== null) {

		// Get all Optins

		$('.' + nnr_of_data.prefix_dash + 'wrap').each(function( index ) {

			var wrap = $(this);

			// Add Styling

			addStyling(wrap, false, false);

			// Track Impression

			$(window).on('DOMContentLoaded load resize scroll', function() {
				onVisibilityChange(wrap);
			});

			// Preview

		    if (nnr_of_data.preview) {

			    if (wrap.data('type') == '2' || wrap.data('type') == '4' || wrap.data('type') == '5') {

				    if (wrap.data('type') == '5') {
					    wrap.css('max-width', '250px');
				    } else {
					   	wrap.css('max-width', '700px');
				    }

					wrap.bPopup({
			            modalClose: true,
			            opacity: 0.8,
			            positionStyle: 'fixed', //'fixed' or 'absolute'
			            speed: 400,
			            transition: wrap.data('popup-transition'),
			        });

			    } else if (wrap.data('type') == '1') {
					nnrobots_banner_show(wrap);
			    } else if (wrap.data('type') == '3') {
				    nnrobots_flyout_setup_location(wrap);
				    nnrobots_flyout_show(wrap);
			    }

			    // Exit

			    wrap.find('.' + nnr_of_data.prefix_dash + 'close').click(function(){
					nnrobots_banner_hide(wrap, $(this).hasClass(nnr_of_data.prefix_dash + 'close-button'));
				});

				// Close Popup after clicking close button

			    wrap.find('.' + nnr_of_data.prefix_dash + 'close').click(function() {
				    wrap.bPopup().close();
				    wrap.find('.' + nnr_of_data.prefix_dash + 'video-container iframe').attr('src', $('iframe').attr('src'));
			    });

			    // Close if user clicks outside of popup

				wrap.click(function(e){
					if (wrap.is(e.target)) {
						wrap.bPopup().close();
						wrap.find('.' + nnr_of_data.prefix_dash + 'video-container iframe').attr('src', $('iframe').attr('src'));
					}
				});

				if (wrap.find('.' + nnr_of_data.prefix_dash + 'close-button').length !== 0) {

					wrap.find('.' + nnr_of_data.prefix_dash + 'close-button').click(function(){
						nnrobots_flyout_hide(wrap, true);
					});

				} else {

					// Desktop Version

					$('body').on('click', function(event){

						var container = wrap.find('.' + nnr_of_data.prefix_dash + 'container');

						// Check if a Flyout is currently being displayed
						// Check if button was clicked from Custom button

						var contains_wrap = false;
						$.each($('.' + nnr_of_data.prefix_dash + 'wrap'), function(key, value) {
							if ($.contains(value, event.target)) {
								contains_wrap = true;
							}
						});

						if (!contains_wrap &&
							!$('.' + nnr_of_data.prefix_dash + 'custom-button-' + wrap.data('id')).is(event.target) &&
							!$('.' + nnr_of_data.prefix_dash + 'show').is(event.target) &&
							!container.is(event.target) &&
							container.has(event.target).length === 0) {

							nnrobots_flyout_hide(wrap, false);
						}

					});

					// Mobile Verison

					document.addEventListener('touchstart', function(e) {
					    var container = wrap.find('.' + nnr_of_data.prefix_dash + 'container');

						// Check if a Flyout Fire is currently being displayed
						// Check if button was clicked from Custom button

						var contains_wrap = false;
						$.each($('.' + nnr_of_data.prefix_dash + 'wrap'), function(key, value) {
							if ($.contains(value, event.target)) {
								contains_wrap = true;
							}
						});

						if (!contains_wrap &&
							!$('.' + nnr_of_data.prefix_dash + 'custom-button-' + wrap.data('id')).is(event.target) &&
							!$('.' + nnr_of_data.prefix_dash + 'show').is(event.target) &&
							!container.is(event.target) &&
							container.has(event.target).length === 0) {

							nnrobots_flyout_hide(wrap, false);
						}

					}, false);
				}

		    }

		    // Edit

		    else if ( nnr_of_data.edit ) {

			    wrap.css('margin', '0 auto');

				if (wrap.data('type') == '5') {
				    wrap.css('max-width', '250px');
				    wrap.css('margin', '0 auto');
			    } else if ( wrap.data('type') == '2' || wrap.data('type') == '3' || wrap.data('type') == '4' ) {
				   	wrap.css('max-width', '700px');
				   	wrap.css('display', 'block');
				   	wrap.css('position', 'relative');
			    } else if (wrap.data('type') == '1') {
				    wrap.css('display', 'block');
			    }

			    if (wrap.data('type') == '3') {
				    wrap.find('.' + nnr_of_data.prefix_dash + 'container').css('position', 'relative');
				}

			    wrap.show();
			    wrap.find('.' + nnr_of_data.prefix_dash + 'container').show();
				wrap.find('.' + nnr_of_data.prefix_dash + 'container').css('position', 'static');
		    }

			// Timer

		    else if (!wrap.hasClass(nnr_of_data.prefix_dash + 'seen') && wrap.data('trigger') == 'timer') {

				$(function() {
					var optin_fire_timer = setInterval(function() {
			           	display_optin_fire(wrap, 'timer');
			            clearInterval(optin_fire_timer);
			        }, wrap.data('timer'));

			    });
		    }

		    // Exit Intent

		    else if (!wrap.hasClass(nnr_of_data.prefix_dash + 'seen') && wrap.data('trigger') == 'exit') {

			    var _html = document.documentElement;

			    _html.addEventListener('mouseleave', function(e) {

				    display_optin_fire(wrap, 'exit');

			    });

				_html.addEventListener('keydown', function(e) {

					if (!e.metaKey || e.keyCode !== 76) {
						return;
					}

				    display_optin_fire(wrap, 'exit');
				});
		    }

		    // Scroll

		    else if (wrap.data('trigger') == 'scroll') {

			    $(window).scroll(function (event) {

				    var height = $(document).height();
					var scroll = $(window).scrollTop() + $(window).height();

					if (!wrap.hasClass(nnr_of_data.prefix_dash + 'seen') && wrap.hasClass(nnr_of_data.prefix_dash + 'styled') &&
						parseInt((scroll / height) * 100) >= wrap.data('scroll')) {

						display_optin_fire(wrap, 'scroll');
					}
				});
		    }

		    if ( !nnr_of_data.preview && !nnr_of_data.edit ) {

				// Custom Button

			    $('[data-optin-fire-custom-button="' + wrap.data('id') + '"]').click(function(event){
				    display_optin_fire(wrap, 'button');
				});

				// In Post Content or Widget

				if (wrap.data('type') == '4' || wrap.data('type') == '5') {
					display_optin_fire(wrap, 'none');
				}

				// Banner

				if (wrap.data('type') == '1') {

					wrap.find('.' + nnr_of_data.prefix_dash + 'close').click(function(){

						if ($(this).hasClass(nnr_of_data.prefix_dash + 'close-button') && wrap.data('dont-show-again')) {
							var data = {
								'action': 'nnr_of_set_close_cookie',
								'optin_fire_id': $(this).closest('.' + nnr_of_data.prefix_dash + 'wrap').attr('data-id')
							};
							// We can also pass the url value separately from ajaxurl for front end AJAX implementations
							$.post(nnr_of_data.ajaxurl, data, function(response) {
								console.log(response);
							});
						}

						nnrobots_banner_hide(wrap, $(this).hasClass(nnr_of_data.prefix_dash + 'close-button'));
					});

					wrap.find('.' + nnr_of_data.prefix_dash + 'show').click(function(){
						nnrobots_banner_show(wrap);
					});
				}

				// Popup

				else if (wrap.data('type') == '2') {

					// Close Popup after clicking close button

				    wrap.find('.' + nnr_of_data.prefix_dash + 'close').click(function() {

					    if (wrap.data('dont-show-again')) {

							var data = {
								'action': 'nnr_of_set_close_cookie',
								'optin_fire_id': $(this).closest('.' + nnr_of_data.prefix_dash + 'wrap').attr('data-id')
							};
							// We can also pass the url value separately from ajaxurl for front end AJAX implementations
							$.post(nnr_of_data.ajaxurl, data, function(response) {
								console.log(response);
							});
					    }

					    wrap.bPopup().close();
					    wrap.find('.' + nnr_of_data.prefix_dash + 'video-container iframe').attr('src', $('iframe').attr('src'));
				    });

				    // Close if user clicks outside of popup

					wrap.click(function(e){
						if (wrap.is(e.target)) {
							wrap.bPopup().close();
							wrap.find('.' + nnr_of_data.prefix_dash + 'video-container iframe').attr('src', $('iframe').attr('src'));
						}
					});
				}

				// Flyout

				else if (wrap.data('type') == '3') {

					// Location Setup

					nnrobots_flyout_setup_location(wrap);

					wrap.find('.' + nnr_of_data.prefix_dash + 'show').click(function(){
						nnrobots_flyout_show(wrap);
					});

					if (wrap.find('.' + nnr_of_data.prefix_dash + 'close-button').length !== 0) {

						wrap.find('.' + nnr_of_data.prefix_dash + 'close-button').click(function(){

							if (wrap.data('dont-show-again')) {
								var data = {
									'action': 'nnr_of_set_close_cookie',
									'optin_fire_id': $(this).closest('.' + nnr_of_data.prefix_dash + 'wrap').attr('data-id')
								};
								// We can also pass the url value separately from ajaxurl for front end AJAX implementations
								$.post(nnr_of_data.ajaxurl, data, function(response) {
									console.log(response);
								});
							}

							nnrobots_flyout_hide(wrap, true);

						});

					} else {

						// Desktop Version

						$('body').on('click', function(event){

							var container = wrap.find('.' + nnr_of_data.prefix_dash + 'container');

							// Check if a Flyout is currently being displayed
							// Check if button was clicked from Custom button

							var contains_wrap = false;
							$.each($('.' + nnr_of_data.prefix_dash + 'wrap'), function(key, value) {
								if ($.contains(value, event.target)) {
									contains_wrap = true;
								}
							});

							if (!contains_wrap &&
								!$('.' + nnr_of_data.prefix_dash + 'custom-button-' + wrap.data('id')).is(event.target) &&
								!$('.' + nnr_of_data.prefix_dash + 'show').is(event.target) &&
								!container.is(event.target) &&
								container.has(event.target).length === 0) {

								nnrobots_flyout_hide(wrap, false);
							}

						});

						// Mobile Verison

						document.addEventListener('touchstart', function(e) {
						    var container = wrap.find('.' + nnr_of_data.prefix_dash + 'container');

							// Check if a Flyout Fire is currently being displayed
							// Check if button was clicked from Custom button

							var contains_wrap = false;
							$.each($('.' + nnr_of_data.prefix_dash + 'wrap'), function(key, value) {
								if ($.contains(value, event.target)) {
									contains_wrap = true;
								}
							});

							if (!contains_wrap &&
								!$('.' + nnr_of_data.prefix_dash + 'custom-button-' + wrap.data('id')).is(event.target) &&
								!$('.' + nnr_of_data.prefix_dash + 'show').is(event.target) &&
								!container.is(event.target) &&
								container.has(event.target).length === 0) {

								nnrobots_flyout_hide(wrap, false);
							}

						}, false);
					}
				}

				// Track clicked links

				$(wrap).click(function(event){

					// Link was clicked

					if ($(event.target).closest('a').length &&
						!$(event.target).is('.' + nnr_of_data.prefix_dash + 'no') &&
						!$(event.target).is('.' + nnr_of_data.prefix_dash + 'no-text') &&
						!$(event.target).is('.' + nnr_of_data.prefix_dash + 'no-sub-text')) {

						var data = {
							'action': 'nnr_of_record_click',
							'optin_fire_id': $(this).closest('.' + nnr_of_data.prefix_dash + 'wrap').attr('data-id')
						};
						// We can also pass the url value separately from ajaxurl for front end AJAX implementations
						$.post(nnr_of_data.ajaxurl, data, function(response) {
							console.log(response);
						});

					}
				});

				// Move to correct placement after X paragraphs

				if (wrap.data('type') == '4' && wrap.data('placement') == 'paragraphs') {

					var paragraphs = wrap.data('paragraphs');

					if (wrap.data('paragraphs') > $('.entry-content').children('p').length) {
						paragraphs = $('.entry-content').children('p').length;
					}

					wrap.insertAfter(".entry-content > p:nth-of-type(" + paragraphs + ")");
				}

				// Newsletter submission

				wrap.find('.' + nnr_of_data.prefix_dash + 'newsletter').submit(function(event){

					if ($(this).find('.' + nnr_of_data.prefix_dash + 'submit-spinner').length != 0) {
						return false;
					}

				    $(this).find('.' + nnr_of_data.prefix_dash + 'submit')
				    	.append('<i style="margin-left: 10px;" class="' + nnr_of_data.prefix_dash + 'submit-spinner fa fa-spinner fa-spin"></i>');

				    event.preventDefault();

					var data = {
						'action': 'nnr_of_add_email',
						'optin_fire_id': $(this).closest('.' + nnr_of_data.prefix_dash + 'wrap').attr('data-id'),
						'type': $(this).find('.' + nnr_of_data.prefix_dash + 'newsletter-type').data('newsletter'),
						'email': $(this).find('.' + nnr_of_data.prefix_dash + 'email').val(),
						'first_name': $(this).find('.' + nnr_of_data.prefix_dash + 'first-name').val(),
						'last_name': $(this).find('.' + nnr_of_data.prefix_dash + 'last-name').val(),
					};

					$.post(nnr_of_data.ajaxurl, data, function(response) {

						response = jQuery.parseJSON(response);
						console.log(response.conversion);

						// Success

						if ( response.status == 'check' ) {

							// Redirect

							if (response.success_action == 'redirect') {

								var win = window.open(response.url, '_self');
								win.focus();

							}

							// Message

							else {

								$('.' + nnr_of_data.prefix_dash + 'wrap-' + response.id)
									.find('.' + nnr_of_data.prefix_dash + 'message')
									.html('<i class="fa fa-' + response.status + '"></i> <span>' + response.message + '</span>');

								$('.' + nnr_of_data.prefix_dash + 'wrap-' + response.id)
									.find('.' + nnr_of_data.prefix_dash + 'message')
									.removeClass('hidden')
									.css('display', 'inline-block');

							}
						}

						// Error

						else {


							$('.' + nnr_of_data.prefix_dash + 'wrap-' + response.id)
								.find('.' + nnr_of_data.prefix_dash + 'message')
								.html('<i class="fa fa-' + response.status + '"></i> <span>' + response.message + '</span>');

							$('.' + nnr_of_data.prefix_dash + 'wrap-' + response.id)
								.find('.' + nnr_of_data.prefix_dash + 'message')
								.removeClass('hidden')
								.css('display', 'inline-block');
						}

						$('.' + nnr_of_data.prefix_dash + 'wrap-' + response.id).find('.' + nnr_of_data.prefix_dash + 'submit-spinner').remove();

					});

				});

				// Contact Us form

				wrap.find('.' + nnr_of_data.prefix_dash + 'contact-us').submit(function(event){

					if ($(this).find('.' + nnr_of_data.prefix_dash + 'submit-spinner').length != 0) {
						return false;
					}

					$(this).find('.' + nnr_of_data.prefix_dash + 'submit')
						.append('<i style="margin-left: 10px;" class="' + nnr_of_data.prefix_dash + 'submit-spinner fa fa-spinner fa-spin"></i>');

				    event.preventDefault();

					var data = {
						'action': 'nnr_of_send_email',
						'optin_fire_id': $(this).closest('.' + nnr_of_data.prefix_dash + 'wrap').attr('data-id'),
						'send': $(this).find('.' + nnr_of_data.prefix_dash + 'send').val(),
						'email': $(this).find('.' + nnr_of_data.prefix_dash + 'email').val(),
						'subject': $(this).find('.' + nnr_of_data.prefix_dash + 'subject').val(),
						'message': $(this).find('.' + nnr_of_data.prefix_dash + 'message-text').val(),
					};

					// We can also pass the url value separately from ajaxurl for front end AJAX implementations
					jQuery.post(nnr_of_data.ajaxurl, data, function(response) {
						response = jQuery.parseJSON(response);
						console.log(response.conversion);
						console.log(response.entry);

						$('.' + nnr_of_data.prefix_dash + 'wrap-' + response.id)
							.find('.' + nnr_of_data.prefix_dash + 'submit-spinner').remove();
						$('.' + nnr_of_data.prefix_dash + 'wrap-' + response.id)
							.find('.' + nnr_of_data.prefix_dash + 'message')
							.html('<i class="fa fa-' + response.status + '"></i> <span>' + response.message + '</span>')
							.css('display', 'inline-block');;

						// Dismiss flyout on a successful entry

						if (response.status == 'check') {

						}

					});
				});

			}

		});
    }

	/**
	 *  Display a Optin
	 *
	 * @access public
	 * @return void
	 */
	function display_optin_fire(wrap, trigger) {

		//console.log('Trying to display Optin: ' + wrap.data('id'));

		addStyling(wrap, true, false);

	}

	/**
	 * Setup the Flyout Fire location
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function nnrobots_flyout_setup_location(wrap) {

		var container = wrap.find('.' + nnr_of_data.prefix_dash + 'container');
		var stub = wrap.find('.' + nnr_of_data.prefix_dash + 'stub');

		var container_width = container.outerWidth() + 20;
		var container_height = container.outerHeight() + 20;
		var stub_width = stub.outerWidth();
		var stub_height = stub.outerHeight();

		if ( wrap.data('flyout-location') == 4 || wrap.data('flyout-location') == 6 ) {

			$(window).resize(function(){

			    wrap.find('.' + nnr_of_data.prefix_dash + 'container').css({
			        position:'fixed',
			        top: ($(window).height() - wrap.find('.' + nnr_of_data.prefix_dash + 'container').outerHeight())/2
			    });

			    wrap.find('.' + nnr_of_data.prefix_dash + 'stub').css({
			        position:'fixed',
			        top: ($(window).height() - wrap.find('.' + nnr_of_data.prefix_dash + 'stub').outerHeight())/2
			    });

			});

			$(window).resize();
		}

		switch (wrap.data('flyout-location')) {

			case 1:

				if (wrap.data('slide-direction') == 'up') {
					stub.css('top', '-' + stub_height + 'px');
					container.css('top', '-' + container_height + 'px');
				} else {
					stub.css('left', '-' + stub_width + 'px');
					container.css('left', '-' + container_width + 'px');
				}

				break;

			case 2:

				stub.css('top', '-' + stub_height + 'px');
				container.css('top', '-' + container_height + 'px');

				break;

			case 3:

				if (wrap.data('slide-direction') == 'up') {
					stub.css('top', '-' + stub_height + 'px');
					container.css('top', '-' + container_height + 'px');
				} else {
					stub.css('right', '-' + stub_width + 'px');
					container.css('right', '-' + container_width + 'px');
				}

				break;

			case 4:

				stub.css('left', '-' + stub_width + 'px');
				container.css('left', '-' + container_width + 'px');

				break;

			case 6:

				stub.css('right', '-' + stub_width + 'px');
				container.css('right', '-' + container_width + 'px');

				break;

			case 7:

				if (wrap.data('slide-direction') == 'down') {
					stub.css('bottom', '-' + stub_height + 'px');
					container.css('bottom', '-' + container_height + 'px');
				} else {
					stub.css('left', '-' + stub_width + 'px');
					container.css('left', '-' + container_width + 'px');
				}

				break;

			case 8:

				stub.css('bottom', '-' + stub_height + 'px');
				container.css('bottom', '-' + container_height + 'px');

				break;

			case 9:

				if (wrap.data('slide-direction') == 'down') {
					stub.css('bottom', '-' + stub_height + 'px');
					container.css('bottom', '-' + container_height + 'px');
				} else {
					stub.css('right', '-' + stub_width + 'px');
					container.css('right', '-' + container_width + 'px');
				}

				break;
		}
	}

	/**
	 * Hide firebar based on location and what slide direction
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function nnrobots_flyout_hide(wrap, close_button) {

		var width = (wrap.find('.' + nnr_of_data.prefix_dash + 'container').outerWidth() + 20);
		var height = (wrap.find('.' + nnr_of_data.prefix_dash + 'container').outerHeight() + 20);

		var stub_animation, container_animation;

		switch (wrap.data('flyout-location')) {

			case 1:

				if (wrap.data('slide-direction') == 'up') {
					stub_animation  = {top: '0px'};
					container_animation = {top: '-=' + height + 'px'};
				} else {
					stub_animation  = {left: '0px'};
					container_animation = {left: '-=' + width + 'px'};
				}

				break;

			case 2:

				stub_animation  = {top: '0px'};
				container_animation = {top: '-=' + height + 'px'};

				break;

			case 3:

				if (wrap.data('slide-direction') == 'up') {
					stub_animation  = {top: '0px'};
					container_animation = {top: '-=' + height + 'px'};
				} else {
					stub_animation  = {right: '0px'};
					container_animation = {right: '-=' + width + 'px'};
				}

				break;

			case 4:

				stub_animation  = {left: '0px'};
				container_animation = {left: '-=' + width + 'px'};

				break;

			case 6:

				stub_animation  = {right: '0px'};
				container_animation = {right: '-=' + width + 'px'};

				break;

			case 7:

				if (wrap.data('slide-direction') == 'down') {
					stub_animation  = {bottom: '0px'};
					container_animation = {bottom: '-=' + height + 'px'};
				} else {
					stub_animation  = {left: '0px'};
					container_animation = {left: '-=' + width + 'px'};
				}

				break;

			case 8:

				stub_animation  = {bottom: '0px'};
				container_animation = {bottom: '-=' + height + 'px'};

				break;

			case 9:

				if (wrap.data('slide-direction') == 'down') {
					stub_animation  = {bottom: '0px'};
					container_animation = {bottom: '-=' + height + 'px'};
				} else {
					stub_animation  = {right: '0px'};
					container_animation = {right: '-=' + width + 'px'};
				}

				break;
		}

		if (wrap.data('full') == 'yes' && wrap.data('push-pull') == 'yes') {

			if (wrap.data('flyout-location') == '1' || wrap.data('flyout-location') == '2' || wrap.data('flyout-location') == '3') {
				$('body').animate({
					top: '-=' + height + 'px',
					complete: function(){
						$('body').css('position', 'initial');
					}
				});
			} else if (wrap.data('flyout-location') == '4') {
				$('body').animate({
					left: '-=' + width + 'px',
					complete: function(){
						$('body').css('position', 'initial');
					}
				});
			} else if (wrap.data('flyout-location') == '6') {
				$('body').animate({
					right: '-=' + width + 'px',
					complete: function(){
						$('body').css('position', 'initial');
					}
				});
			} else if (wrap.data('flyout-location') == '7' || wrap.data('flyout-location') == '8' || wrap.data('flyout-location') == '9') {
				$('body').animate({
					bottom: '-=' + height + 'px',
					complete: function(){
						$('body').css('position', 'initial');
					}
				});
			}
		}

		if (close_button) {
			wrap.find('.' + nnr_of_data.prefix_dash + 'container').animate(container_animation, 500, function() {});
		} else {
			wrap.find('.' + nnr_of_data.prefix_dash + 'show').show();

			wrap.find('.' + nnr_of_data.prefix_dash + 'container').animate(container_animation, 500, function() {
				wrap.find('.' + nnr_of_data.prefix_dash + 'stub').animate(stub_animation);
			});
		}

	}

	/**
	 * Hide the Banner
	 *
	 * @access public
	 * @param mixed location
	 * @return void
	 */
	function nnrobots_banner_hide(wrap, close_button) {

		var container = '.' + nnr_of_data.prefix_dash + 'container-' + wrap.data('banner-location');
		var stub = '.' + nnr_of_data.prefix_dash + 'stub-' + wrap.data('banner-location');

		if (close_button) {

			if (wrap.data('banner-animation') == 'yes') {

				wrap.find(container).slideUp('normal', function() {});

			} else {
				wrap.find(container).hide();
			}

			// Move Body

			if (wrap.data('move-body') == 'yes') {
				if (wrap.data('banner-location') == 'top') {
					$('body').animate({paddingTop: '0px'}, 300);
				} else {
					$('body').animate({paddingBottom: '0px'}, 300);
				}
	      	}

		} else {

			if (wrap.data('banner-animation') == 'yes') {

				wrap.find(container).slideUp('normal', function() {
					wrap.find(stub).show({effect: wrap.data('effect')}, 500);
				});

			} else {
				wrap.find(container).hide();
				wrap.find(stub).show();
			}

			// Move Body

			if (wrap.data('move-body') == 'yes') {
				if (wrap.data('banner-location') == 'top') {
					$('body').animate({paddingTop: '0px'}, 300);
				} else {
					$('body').animate({paddingBottom: '0px'}, 300);
				}
	      	}
		}

	}

	/**
	 * Get all text nodes and wrap in p tags
	 *
	 * @access public
	 * @param mixed node
	 * @param mixed includeWhitespaceNodes
	 * @return void
	 */
	function nnrobots_marekting_suite_getTextNodesIn(node, includeWhitespaceNodes) {
	    var textNodes = [], whitespace = /^\s*$/;

	    function nnrobots_marekting_suite_getTextNodes(node) {
	        if (node.nodeType == 3) {
	            if (includeWhitespaceNodes || !whitespace.test(node.nodeValue)) {
	                textNodes.push(node);
	            }
	        } else {
	            for (var i = 0, len = node.childNodes.length; i < len; ++i) {
	                nnrobots_marekting_suite_getTextNodes(node.childNodes[i]);
	            }
	        }
	    }

	    nnrobots_marekting_suite_getTextNodes(node);
	    return textNodes;
	}

});

/*================================================================================
 * @name: bPopup - if you can't get it up, use bPopup
 * @author: (c)Bjoern Klinggaard (twitter@bklinggaard)
 * @demo: http://dinbror.dk/bpopup
 * @version: 0.11.0.min
 ================================================================================*/
 (function(c){c.fn.bPopup=function(A,E){function L(){a.contentContainer=c(a.contentContainer||b);switch(a.content){case "iframe":var d=c('<iframe class="b-iframe" '+a.iframeAttr+"></iframe>");d.appendTo(a.contentContainer);t=b.outerHeight(!0);u=b.outerWidth(!0);B();d.attr("src",a.loadUrl);l(a.loadCallback);break;case "image":B();c("<img />").load(function(){l(a.loadCallback);F(c(this))}).attr("src",a.loadUrl).hide().appendTo(a.contentContainer);break;default:B(),c('<div class="b-ajax-wrapper"></div>').load(a.loadUrl,a.loadData,function(d,b,e){l(a.loadCallback,b);F(c(this))}).hide().appendTo(a.contentContainer)}}function B(){a.modal&&c('<div class="b-modal '+e+'"></div>').css({backgroundColor:a.modalColor,position:"fixed",top:0,right:0,bottom:0,left:0,opacity:0,zIndex:a.zIndex+v}).appendTo(a.appendTo).fadeTo(a.speed,a.opacity);C();b.data("bPopup",a).data("id",e).css({left:"slideIn"==a.transition||"slideBack"==a.transition?"slideBack"==a.transition?f.scrollLeft()+w:-1*(x+u):m(!(!a.follow[0]&&n||g)),position:a.positionStyle||"absolute",top:"slideDown"==a.transition||"slideUp"==a.transition?"slideUp"==a.transition?f.scrollTop()+y:z+-1*t:p(!(!a.follow[1]&&q||g)),"z-index":a.zIndex+v+1}).each(function(){a.appending&&c(this).appendTo(a.appendTo)});G(!0)}function r(){a.modal&&c(".b-modal."+b.data("id")).fadeTo(a.speed,0,function(){c(this).remove()});a.scrollBar||c("html").css("overflow","auto");c(".b-modal."+e).unbind("click");f.unbind("keydown."+e);k.unbind("."+e).data("bPopup",0<k.data("bPopup")-1?k.data("bPopup")-1:null);b.undelegate(".bClose, ."+a.closeClass,"click."+e,r).data("bPopup",null);clearTimeout(H);G();return!1}function I(d){y=k.height();w=k.width();h=D();if(h.x||h.y)clearTimeout(J),J=setTimeout(function(){C();d=d||a.followSpeed;var e={};h.x&&(e.left=a.follow[0]?m(!0):"auto");h.y&&(e.top=a.follow[1]?p(!0):"auto");b.dequeue().each(function(){g?c(this).css({left:x,top:z}):c(this).animate(e,d,a.followEasing)})},50)}function F(d){var c=d.width(),e=d.height(),f={};a.contentContainer.css({height:e,width:c});e>=b.height()&&(f.height=b.height());c>=b.width()&&(f.width=b.width());t=b.outerHeight(!0);u=b.outerWidth(!0);C();a.contentContainer.css({height:"auto",width:"auto"});f.left=m(!(!a.follow[0]&&n||g));f.top=p(!(!a.follow[1]&&q||g));b.animate(f,250,function(){d.show();h=D()})}function M(){k.data("bPopup",v);b.delegate(".bClose, ."+a.closeClass,"click."+e,r);a.modalClose&&c(".b-modal."+e).css("cursor","pointer").bind("click",r);N||!a.follow[0]&&!a.follow[1]||k.bind("scroll."+e,function(){if(h.x||h.y){var d={};h.x&&(d.left=a.follow[0]?m(!g):"auto");h.y&&(d.top=a.follow[1]?p(!g):"auto");b.dequeue().animate(d,a.followSpeed,a.followEasing)}}).bind("resize."+e,function(){I()});a.escClose&&f.bind("keydown."+e,function(a){27==a.which&&r()})}function G(d){function c(e){b.css({display:"block",opacity:1}).animate(e,a.speed,a.easing,function(){K(d)})}switch(d?a.transition:a.transitionClose||a.transition){case "slideIn":c({left:d?m(!(!a.follow[0]&&n||g)):f.scrollLeft()-(u||b.outerWidth(!0))-200});break;case "slideBack":c({left:d?m(!(!a.follow[0]&&n||g)):f.scrollLeft()+w+200});break;case "slideDown":c({top:d?p(!(!a.follow[1]&&q||g)):f.scrollTop()-(t||b.outerHeight(!0))-200});break;case "slideUp":c({top:d?p(!(!a.follow[1]&&q||g)):f.scrollTop()+y+200});break;default:b.stop().fadeTo(a.speed,d?1:0,function(){K(d)})}}function K(d){d?(M(),l(E),a.autoClose&&(H=setTimeout(r,a.autoClose))):(b.hide(),l(a.onClose),a.loadUrl&&(a.contentContainer.empty(),b.css({height:"auto",width:"auto"})))}function m(a){return a?x+f.scrollLeft():x}function p(a){return a?z+f.scrollTop():z}function l(a,e){c.isFunction(a)&&a.call(b,e)}function C(){z=q?a.position[1]:Math.max(0,(y-b.outerHeight(!0))/2-a.amsl);x=n?a.position[0]:(w-b.outerWidth(!0))/2;h=D()}function D(){return{x:w>b.outerWidth(!0),y:y>b.outerHeight(!0)}}c.isFunction(A)&&(E=A,A=null);var a=c.extend({},c.fn.bPopup.defaults,A);a.scrollBar||c("html").css("overflow","hidden");var b=this,f=c(document),k=c(window),y=k.height(),w=k.width(),N=/OS 6(_\d)+/i.test(navigator.userAgent),v=0,e,h,q,n,g,z,x,t,u,J,H;b.close=function(){r()};b.reposition=function(a){I(a)};return b.each(function(){c(this).data("bPopup")||(l(a.onOpen),v=(k.data("bPopup")||0)+1,e="__b-popup"+v+"__",q="auto"!==a.position[1],n="auto"!==a.position[0],g="fixed"===a.positionStyle,t=b.outerHeight(!0),u=b.outerWidth(!0),a.loadUrl?L():B())})};c.fn.bPopup.defaults={amsl:50,appending:!0,appendTo:"body",autoClose:!1,closeClass:"b-close",content:"ajax",contentContainer:!1,easing:"swing",escClose:!0,follow:[!0,!0],followEasing:"swing",followSpeed:500,iframeAttr:'scrolling="no" frameborder="0"',loadCallback:!1,loadData:!1,loadUrl:!1,modal:!0,modalClose:!0,modalColor:"#000",onClose:!1,onOpen:!1,opacity:.7,position:["auto","auto"],positionStyle:"absolute",scrollBar:!0,speed:250,transition:"fadeIn",transitionClose:!1,zIndex:9997}})(jQuery);