<?php

// Add classes to the wrap element

if (isset($args['powered_by']) && $args['powered_by']) {
	$wrap_class =
		NNRobots_Optin_Fire::$prefix_dash . 'wrap ' .
		NNRobots_Optin_Fire::$prefix_dash . 'wrap-' . $val['id'] . ' ' .
		NNRobots_Optin_Fire::$prefix_dash . 'has-powered-by';

} else {
	$wrap_class =
		NNRobots_Optin_Fire::$prefix_dash . 'wrap ' .
		NNRobots_Optin_Fire::$prefix_dash . 'wrap-' . $val['id'];
}

if ($widget)  {
	$wrap_class .= ' ' . NNRobots_Optin_Fire::$prefix_dash . 'widget';
}

// Add data attributes to he wrap element

$wrap_data_attrs = 'data-id="' . $val['id'] .
				'" data-type="' . $val['type'] .
				'" data-trigger="' . $trigger['args']['type'] .
				'" data-scroll="' . $trigger['args']['scroll'] .
				'" data-timer="' . $trigger['args']['timer'] .
				'" data-location="' . $template['args']['location'] .
				'" data-banner-location="' . strtolower($template['args']['banner_location']) .
				'" data-banner-display="' . $template['args']['banner_display'] .
				'" data-banner-animation="' . $template['args']['animation'] .
				'" data-popup-animation="' . $template['args']['popup_animation'] .
				'" data-move-body="' . $template['args']['move_body'] .
				'" data-effect="' . $template['args']['effect'] .
				'" data-full="' . $template['args']['full'] .
				'" data-push-pull="' . $template['args']['push_pull'] .
				'" data-flyout-location="' . $template['args']['location'] .
				'" data-slide-direction="' . $template['args']['slide_direction'] .
				'" data-dont-show-again="' . $args['dont_show_again'] .
				'" data-border-size="' . $style['border_size'] .
				'" data-border-color="' . $style['border_color'] . '"';

if ($val['type'] == '4' && $args['placement']['type'] == 'paragraphs') {
	$wrap_data_attrs .= ' data-placement="paragraphs" data-paragraphs="' . $args['placement']['paragraphs'] . '"';
}

$optin_fire_content .= '<div class="' . $wrap_class . '" ' . $wrap_data_attrs .'>';

// Has footer

$has_footer = '';
if ( isset($template['args']['footer']) && $template['args']['footer'] != '') {
	$has_footer = NNRobots_Optin_Fire::$prefix_dash . 'has-footer';
}

// Header

switch ($val['type']) {

	case 1:

		$classes = NNRobots_Optin_Fire_Functions::get_classes($args, $template, $template['args']['banner_location'], $template['args']['stub_location']);
		$close   = '<span class="' . $classes['close'] . '"></span>';

		$optin_fire_content .= '<div class="' . $classes['container'] . '" ' . $background . ' style="display: none;">';
			$optin_fire_content .= '<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'inner">';

				if ($template['args']['stub_location'] == 'left') { $optin_fire_content .= $close; }

	break;

	case 2:

		$optin_fire_content .= '<div class="' .
			NNRobots_Optin_Fire::$prefix_dash . 'container ' .
			$has_footer . ' ' .
			NNRobots_Optin_Fire::$prefix_dash . 'template-' . $template['type'] . '" ' . $background . '>
			<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'close">
				<i class="fa fa-times"></i>
			</span>';

	break;

	case 3:

		$shadow = isset($template['args']['shadow']) && $template['args']['shadow'] == 'yes' ? NNRobots_Optin_Fire::$prefix_dash . 'container-' . strtolower($template['args']['location']) . '-shadow' : '';
		$full = '';

		if (isset($template['args']['full']) && $template['args']['full'] == 'yes') {
			$full = NNRobots_Optin_Fire::$prefix_dash . 'full-width';

			if ($location == 4 || $location == 6) {
				$full = NNRobots_Optin_Fire::$prefix_dash . 'full-height';
			}
		}

		$container = NNRobots_Optin_Fire::$prefix_dash . 'container ' .
			NNRobots_Optin_Fire::$prefix_dash . 'container-' . $template['args']['size'] . ' ' .
			$full . ' ' .
			$has_footer . ' ' .
			NNRobots_Optin_Fire::$prefix_dash . 'container-' . strtolower($template['args']['location']) . ' ' . $shadow;

		$optin_fire_content .= '<div class="' . $container . '" ' . $background . ' style="display:none;">';

		if (  isset($args['close_button']) && $args['close_button'] ) {

			$optin_fire_content .= '<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'close ' . NNRobots_Optin_Fire::$prefix_dash . 'close-button">
				<i class="fa fa-times"></i>
			</span>';
		}

	break;

	case 4:

		$optin_fire_content .= '<div class="' .
			NNRobots_Optin_Fire::$prefix_dash . 'container ' .
			$has_footer . ' ' .
			NNRobots_Optin_Fire::$prefix_dash . 'template-' . $template['type'] . '" ' . $background . '>';

	break;

	case 5:

		$optin_fire_content .= '<div class="' .
			NNRobots_Optin_Fire::$prefix_dash . 'container ' .
			$has_footer . ' ' .
			NNRobots_Optin_Fire::$prefix_dash . 'template-' . $template['type'] . '" ' . $background . '>';

	break;
}

// Body

if (isset($style['custom_css']) && $style['custom_css'] !='') {
	$optin_fire_content .= '<!-- Custom CSS -->';
	$optin_fire_content .= '<style>' . $style['custom_css'] . '</style>';
}

$optin_fire_content .= '<!-- Template Contents -->';

do_action('nnr_of_before_header');
do_action('nnr_of_before_header_' . $val['id']);

// Template content

if ($val['type'] == '1') {
	include('banner.php');
} else if ($val['type'] == '3') {
	include('flyout.php');
} else if ($val['type'] == '5') {
	include('widget.php');
} else {
	include('template-' . $template['type'] . '/template-' . $template['type'] . '.php');
}

do_action('nnr_of_before_footer');
do_action('nnr_of_before_footer_' . $val['id']);

if ( $val['type'] != '1' && isset($template['args']['footer']) && $template['args']['footer'] != '') {

	$optin_fire_content .= '<!-- Footer -->';

	$optin_fire_content .= '<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'footer-container">';
		$optin_fire_content .= '<span class="' . NNRobots_Optin_Fire::$prefix_dash . 'footer">';

			if (isset($template['args']['footer_icon']) && $template['args']['footer_icon'] != '') {
				$optin_fire_content .= '<i class="fa ' . $template['args']['footer_icon'] . '"></i>';
			}

			$optin_fire_content .= NNRobots_Optin_Fire_Functions::output_html_shortcode($template['args']['footer']);
		$optin_fire_content .= '</span>';
	$optin_fire_content .= '</div>';

}

do_action('nnr_of_after_footer');
do_action('nnr_of_after_footer_' . $val['id']);

// Footer

switch ($val['type']) {

	case 1:

		$show         = '<div class="' . $classes['stub'] . '" style="display: none;">';
		$show 		 .= '<span class = "' . NNRobots_Optin_Fire::$prefix_dash . 'show ' .
							 NNRobots_Optin_Fire::$prefix_dash . 'show-' . strtolower($template['args']['banner_location']) . ' ' .
							 NNRobots_Optin_Fire::$prefix_dash . 'show-' . strtolower($template['args']['banner_location']) . '-' .
							  $template['args']['stub_location'] . '-' . $template['args']['stub_shape'] . ' fa ' . $template['args']['icon'] . '"></span>';
		$show        .= '</div>';

				if ($template['args']['stub_location'] == 'right') { $optin_fire_content .= $close; }

			$optin_fire_content .= '</div>';
		$optin_fire_content .= '</div>';
		$optin_fire_content .= $show;

	break;

	case 2:

		$optin_fire_content .= '</div>';

	break;

	case 3:

			$stub = '<div class="' .
				NNRobots_Optin_Fire::$prefix_dash . 'stub ' .
				NNRobots_Optin_Fire::$prefix_dash . 'stub-' . strtolower($template['args']['location']) . ' ' . $full . '">
					<span class="' .
				NNRobots_Optin_Fire::$prefix_dash . 'show ' .
				NNRobots_Optin_Fire::$prefix_dash . 'show-' . strtolower($template['args']['location']) . ' ' .
				NNRobots_Optin_Fire::$prefix_dash . 'show-' . strtolower($template['args']['location']) . '-' . $template['args']['stub_shape'] . ' ' . 'fa ' . $template['args']['icon'] . '" style="display:none;"></span>
				</div>';

			if ($args['powered_by']) {
				$optin_fire_content .= '<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'powered-by">';
					$optin_fire_content .= '<span>' . __('Powered by', NNRobots_Optin_Fire::$text_domain) . '</span> <a href="https://99robots.com/?post_type=download&p=7412&utm_source=optin-fire&utm_medium=plugin&utm_content=credit&utm_campaign=optin-fire-credit-link" target="_blank">' . __('Optin Fire', NNRobots_Optin_Fire::$text_domain) . '</a>';
				$optin_fire_content .= '</div>';
			}

			$optin_fire_content .= '</div>';
		$optin_fire_content .= $stub;


	break;

	case 4:

		$optin_fire_content .= '</div>';

	break;

	case 5:

		$optin_fire_content .= '</div>';

	break;
}

if ( $val['type'] != 1 && $val['type'] != 3 && isset($args['powered_by']) && $args['powered_by'] ) {

	$optin_fire_content .= '<div class="' . NNRobots_Optin_Fire::$prefix_dash . 'powered-by">';
		$optin_fire_content .= '<span>' . __('Powered by', NNRobots_Optin_Fire::$text_domain) . '</span> <a href="https://99robots.com/?post_type=download&p=7412&utm_source=optin-fire&utm_medium=plugin&utm_content=credit&utm_campaign=optin-fire-credit-link" target="_blank">' . __('Optin Fire', NNRobots_Optin_Fire::$text_domain) . '</a>';
	$optin_fire_content .= '</div>';

}

$optin_fire_content .= '<!-- This is used to record stats so please leave it alone -->';
$optin_fire_content .= '<p class="hidden" class="' . NNRobots_Optin_Fire::$prefix_dash . 'optin-fire-id" data-optin-fire-id="' . $val['id'] . '"></p>';
$optin_fire_content .= '<!-- This is used to record stats so please leave it alone -->';

$optin_fire_content .= '</div>';